#include "common.h"


//double Get_distance(LOCATION, LOCATION);

double Get_LCS_theta(double alpha, double beta, double gamma, double GCS_theta, double GCS_pi);
double Get_LCS_pi(double alpha, double beta, double gamma, double GCS_theta, double GCS_pi);

double Get_BS_antenna_pattern(double theta_GCS, double pi_GCS, int bs_idx, int sector_index, double &F_theta_GCS_P1, double &F_pi_GCS_P1, double &F_theta_GCS_P2, double &F_pi_GCS_P2);
double Get_UE_antenna_pattern(int P, double theta_GCS, double pi_GCS, int ms_idx, int sector_index, double &F_theta_GCS_P1, double &F_pi_GCS_P1, double &F_theta_GCS_P2, double &F_pi_GCS_P2);

complex <double> Get_BS_antenna_field_pattern(LOCATION interferer, int _bs_idx, int _sec_idx, int tilt_z_idx, int tilt_a_idx, double v_angle_theta, double h_angle_pi, double F_theta_GCS_P1, double F_pi_GCS_P1, double F_theta_GCS_P2, double F_pi_GCS_P2, complex <double> &F_tx_theta, complex <double> &F_tx_pi);
complex <double> Get_UE_antenna_field_pattern(LOCATION UE , int M, int N, int P, int ms_idx, int sector_idx, int tilt_z_idx, int tilt_a_idx, double v_angle_theta, double h_angle_pi, double F_theta_GCS_P1, double F_pi_GCS_P1, double F_theta_GCS_P2, double F_pi_GCS_P2, complex <double> &F_rx_theta_panel_1, complex <double> &F_rx_pi_panel_1, complex <double> &F_rx_theta_panel_2, complex <double> &F_rx_pi_panel_2);

MatrixXd Get_distance_angular(double a, double b, double c, double x, double y, double z);
void LCS_Antenna_field_to_GCS_antenna_pattern(double alpha, double beta, double gamma, double GCS_angle_theta, double GCS_angle_pi, double LCS_field_theta, double LCS_field_pi, double &GCS_field_theta, double &GCS_field_pi); //GCS_angle degree
void PIot_sector_antenna_gain();
void PIot_ue_antenna_gain();
ANTENNA_FIELD Antenna_field_in_LCS(double LCS_antenna_gain_in_dB, double zeta);
double dot(LOCATION3D a, LOCATION3D b);
ANTENNA_FIELD LCS_Antenna_field_to_GCS_antenna_pattern_rev(double alpha, double beta, double gamma, SPHERICAL_ANGLE GCS_angle, ANTENNA_FIELD LCS_field);
LOCATION3D Transform_angle_to_spheical_vector(double phi, double theta);
SPHERICAL_ANGLE GCS_Angle_to_LCS_Angle(double alpha, double beta, double gamma, SPHERICAL_ANGLE GCS_angle);
double Sector_Antenna_gain_in_dB(SPHERICAL_ANGLE LCS_angle);
double UE_Antenna_gain_in_dB(SPHERICAL_ANGLE LCS_angle); //LCS_angle : degree

complex <double> Generate_vertical_virtualization_weight_link(double theta, double dv, double k, double K);
complex <double> Generate_horizontal_virtualization_weight_link(double theta, double phi, double dH, double l, double L);

double Transform_angle_minus_180_to_plus_180(double x);
double Transform_angle_0_to_plus_180(double x);



void LINK::Configuration(int _self_ms_idx)
{
	self_ms_idx= _self_ms_idx;

	if (self_ms_idx == 0)
	{
		//PIot_sector_antenna_gain();
		//PIot_ue_antenna_gain();
	}



	UE_Initial_Setting();

	Get_signal_interference();

	Get_adj_SECTORS();


	SINR = 10. * log10(pow(10., signal / 10.) / (pow(10., interference / 10.) + pow(10., (noise + MS_noisefig) / 10.)));

}



void LINK::Get_signal_interference()
{

	double strongest_signal;
	double pathloss;
	double antgain;
	double random_antgain;
	double max_array_factor_gain = 0;
	double random_array_factor_gain = 0;  /// for interference
	double UE_max_array_factor_gain = 0;
	double UE_random_array_factor_gain = 0;
	double RMS_delay;
	double AOA_spread;
	double AOD_spread;
	double distance;
	double UE_antenna_gain = 0.;
	interference = 0.;
	double RSRP_antgain = 0;
	double RSRP_signal = 0;
	double MAX_RSRP_antgain = 0.;
	//double MAX_RSRP_signal = 0.;
	double random_RSRP_antgain = 0;
	//link_array_factor[] = 0;

	if (TYPE == 11 && (num_Indoor_TRxP == 1)) //// 5G InH, 12 TRxP
	{
		///////////////////////////////////////////////////////////////// Get Signal ////////////////
		for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
		{
			pathloss = channel[bs_idx][self_ms_idx].pathloss;
			RMS_delay = channel[bs_idx][self_ms_idx].RMS_delay_spread;
			AOA_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOA;
			AOD_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOD;
			distance = channel[bs_idx][self_ms_idx].distance;

			//pathloss = pathloss + ms[self_ms_idx].LSPs[bs_idx](0);   ////// Add Shadow Fading
			pathloss = pathloss + channel[bs_idx][self_ms_idx].sigma_SF * randnum.n();   ////// Add Shadow Fading

			channel[bs_idx][self_ms_idx].pathloss_final = pathloss;

			///*
			//////////////////////////////////////////////////////////////////////////////////////////////////////////
			//////////////////////////////////////   Antenna gain - NEW version //////////////////////////////////////
			//////////////////////////////////////////////////////////////////////////////////////////////////////////
			for (int a = 0; a < tilt_azimuth_angle_LCS_size; a++)
			{
				for (int z = 0; z < tilt_zenith_angle_LCS_size; z++)
				{
					antgain = Get_antgain(channel[bs_idx][self_ms_idx].self_bs, channel[bs_idx][self_ms_idx].self_ms, bs_idx, 0, a, z);   ///// MAX antgain - combined gain

					Get_TX_SmallScale_antgain(channel[bs_idx][self_ms_idx].self_bs, bs_idx, 0, a, z);

					RSRP_antgain = Get_RSRP(bs_idx, self_ms_idx,0,z,a, 0);

					if (a == 0 && z == 0)  // first loop
					{
						MAX_RSRP_antgain = RSRP_antgain;

						azimuth_angle_idx_selected = selected_a;
						zenith_angle_idx_selected  = selected_z;
						panel_idx_selected         = selected_p;

						sector_a = a;
						sector_z = z;


					}
					else if (MAX_RSRP_antgain < RSRP_antgain)   // find max 
					{
						MAX_RSRP_antgain = RSRP_antgain;

						azimuth_angle_idx_selected = selected_a;
						zenith_angle_idx_selected  = selected_z;
						panel_idx_selected         = selected_p;

						sector_a = a;
						sector_z = z;
					}
					else
					{
						MAX_RSRP_antgain = MAX_RSRP_antgain;
					}
				}
			}

			signal = bs_maxpower + MAX_RSRP_antgain - pathloss;


			//*/
			//////////////////////////////////////////////////////////////////////////////////////////////////////////
			//////////////////////////////////////////////////////////////////////////////////////////////////////////

			if (bs_idx == 0)
			{
				strongest_signal = signal;
				link_prev_MAX_RSRP = MAX_RSRP_antgain;
				link_prev_Random_RSRP = random_RSRP_antgain;

				self_bs_idx = bs_idx;
				self_sector_idx = 1;
				link_pathloss = pathloss;
				link_antgain = RSRP_antgain;
				link_RMS_delay_spread = RMS_delay;
				link_AOA_spread = AOA_spread;
				link_AOD_spread = AOD_spread;
				link_distance = distance;

				azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
				zenith_angle_idx_selected_for_interference = zenith_angle_idx_selected;
				panel_idx_selected_for_interference = panel_idx_selected;

				sector_azimuth_angle_idx = sector_a;
				sector_zenith_angle_idx = sector_z;

				// indoor num_BS = num_sector , bs = sector 

				_sector_in_control = self_bs_idx;

			}
			else if (signal > strongest_signal)
			{

				if (Configuration_Type == 0)  // config A
				{
					interference += pow(10., (strongest_signal) / 10.);
				}
				else
				{
					//interference += pow(10., (strongest_signal - link_prev_MAX_RSRP + link_prev_Random_RSRP) / 10.);
				}

				strongest_signal = signal;
				link_prev_MAX_RSRP = MAX_RSRP_antgain;
				link_prev_Random_RSRP = random_RSRP_antgain;

				self_bs_idx = bs_idx;
				self_sector_idx = 1;
				link_pathloss = pathloss;
				link_antgain = RSRP_antgain;
				link_RMS_delay_spread = RMS_delay;
				link_AOA_spread = AOA_spread;
				link_AOD_spread = AOD_spread;
				link_distance = distance;

				azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
				zenith_angle_idx_selected_for_interference = zenith_angle_idx_selected;
				panel_idx_selected_for_interference = panel_idx_selected;

				sector_azimuth_angle_idx = sector_a;
				sector_zenith_angle_idx = sector_z;


				_sector_in_control = self_bs_idx;

			}
			else
			{
				if (Configuration_Type == 0)  // config A
				{
					interference += pow(10., (signal) / 10.);
				}
				else
				{
					//interference += pow(10., (signal - MAX_RSRP_antgain + random_RSRP_antgain) / 10.);
				}
			}
		}

		//
		/////////////////////// Get interference ///////////////////////////////////////////////////////////////////////////////////////////////////////
		//
		
		for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
		{
			pathloss = channel[bs_idx][self_ms_idx].pathloss_final;

			if (Configuration_Type == 0)
			{
			}
			else
			{
				///////////////////////////////////////////////////////////////// random beam interference
				int aa = (int)(tilt_azimuth_angle_LCS_size * randnum.u());
				int zz = (int)(tilt_zenith_angle_LCS_size * randnum.u());

				random_antgain = Get_antgain(channel[bs_idx][self_ms_idx].self_bs, channel[bs_idx][self_ms_idx].self_ms, bs_idx, 0, aa, zz);   ///// MAX antgain - combined gain
				Get_TX_SmallScale_antgain(channel[bs_idx][self_ms_idx].self_bs, bs_idx, 0, aa, zz);
				random_RSRP_antgain = Get_RSRP(bs_idx, self_ms_idx, 0, zz, aa, 1);
				/////////////////////////////////////////////////////////////////

				signal = bs_maxpower + random_RSRP_antgain - pathloss;
			}

			if (bs_idx != self_bs_idx)
			{
				if (Configuration_Type == 0)  // config A
				{

				}
				else
				{
					interference += pow(10., (signal) / 10.);
				}
			}
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	}
	else if (TYPE == 11 && (num_Indoor_TRxP == 3)) //// 5G InH, 36 TRxP
	{
		for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
		{
			pathloss = channel[bs_idx][self_ms_idx].pathloss;
			RMS_delay = channel[bs_idx][self_ms_idx].RMS_delay_spread;
			AOA_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOA;
			AOD_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOD;
			distance = channel[bs_idx][self_ms_idx].distance;

			pathloss = pathloss + channel[bs_idx][self_ms_idx].sigma_SF * randnum.n();   ////// Add Shadow Fading

			channel[bs_idx][self_ms_idx].pathloss_final = pathloss;


			for (int sector_idx = 1; sector_idx < 4; sector_idx++)
			{
				///*
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				//////////////////////////////////////   Antenna gain - NEW version //////////////////////////////////////
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				for (int a = 0; a < tilt_azimuth_angle_LCS_size; a++)
				{
					for (int z = 0; z < tilt_zenith_angle_LCS_size; z++)
					{
						antgain = Get_antgain(channel[bs_idx][self_ms_idx].self_bs, channel[bs_idx][self_ms_idx].self_ms, bs_idx, sector_idx-1, a, z);   ///// MAX antgain - combined gain

						Get_TX_SmallScale_antgain(channel[bs_idx][self_ms_idx].self_bs, bs_idx, sector_idx - 1, a, z);

						RSRP_antgain = Get_RSRP(bs_idx, self_ms_idx,(sector_idx-1),z,a, 0);

						if (a == 0 && z == 0)  // first loop
						{
							MAX_RSRP_antgain = RSRP_antgain;

							azimuth_angle_idx_selected = selected_a;
							zenith_angle_idx_selected  = selected_z;
							panel_idx_selected         = selected_p;

							sector_a = a;
							sector_z = z;
						}
						else if (MAX_RSRP_antgain < RSRP_antgain)   // find max 
						{
							MAX_RSRP_antgain = RSRP_antgain;

							azimuth_angle_idx_selected = selected_a;
							zenith_angle_idx_selected  = selected_z;
							panel_idx_selected         = selected_p;

							sector_a = a;
							sector_z = z;
						}
						else
						{
							MAX_RSRP_antgain = MAX_RSRP_antgain;
						}
					}
				}

				signal = bs_maxpower + MAX_RSRP_antgain - pathloss;

				//*/
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				//////////////////////////////////////////////////////////////////////////////////////////////////////////

				if (bs_idx == 0)
				{
					strongest_signal = signal;
					link_prev_MAX_RSRP = MAX_RSRP_antgain;
					link_prev_Random_RSRP = random_RSRP_antgain;

					self_bs_idx = bs_idx;
					self_sector_idx = sector_idx;
					link_pathloss = pathloss;
					link_antgain = RSRP_antgain;
					link_RMS_delay_spread = RMS_delay;
					link_AOA_spread = AOA_spread;
					link_AOD_spread = AOD_spread;
					link_distance = distance;

					azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
					zenith_angle_idx_selected_for_interference = zenith_angle_idx_selected;
					panel_idx_selected_for_interference = panel_idx_selected;

					sector_azimuth_angle_idx = sector_a;
					sector_zenith_angle_idx = sector_z;

					// 

					_sector_in_control = self_bs_idx * 3 + (self_sector_idx - 1);

				}
				else if (signal > strongest_signal)
				{

					if (Configuration_Type == 0)  // config A
					{
						interference += pow(10., (strongest_signal) / 10.);
					}
					else
					{
						//interference += pow(10., (strongest_signal - link_prev_MAX_RSRP + link_prev_Random_RSRP) / 10.);
					}

					strongest_signal = signal;
					link_prev_MAX_RSRP = MAX_RSRP_antgain;
					link_prev_Random_RSRP = random_RSRP_antgain;

					self_bs_idx = bs_idx;
					self_sector_idx = sector_idx;
					link_pathloss = pathloss;
					link_antgain = RSRP_antgain;
					link_RMS_delay_spread = RMS_delay;
					link_AOA_spread = AOA_spread;
					link_AOD_spread = AOD_spread;
					link_distance = distance;

					azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
					zenith_angle_idx_selected_for_interference = zenith_angle_idx_selected;
					panel_idx_selected_for_interference = panel_idx_selected;

					sector_azimuth_angle_idx = sector_a;
					sector_zenith_angle_idx = sector_z;


					_sector_in_control = self_bs_idx * 3 + (self_sector_idx - 1);

				}
				else
				{
					if (Configuration_Type == 0)  // config A
					{
						interference += pow(10., (signal) / 10.);
					}
					else
					{
						//interference += pow(10., (signal - MAX_RSRP_antgain + random_RSRP_antgain) / 10.);
					}
				}
			}
			
		}

		//
		/////////////////////// Get interference ///////////////////////////////////////////////////////////////////////////////////////////////////////
		//
		
		for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
		{
			pathloss = channel[bs_idx][self_ms_idx].pathloss_final;

			for (int sector_idx = 1; sector_idx < 4; sector_idx++)
			{

				if (Configuration_Type == 0)
				{
					// 
				}
				else
				{
					///////////////////////////////////////////////////////////////// random beam interference
					int aa = (int)(tilt_azimuth_angle_LCS_size * randnum.u());
					int zz = (int)(tilt_zenith_angle_LCS_size * randnum.u());

					random_antgain = Get_antgain(channel[bs_idx][self_ms_idx].self_bs, channel[bs_idx][self_ms_idx].self_ms, bs_idx, sector_idx - 1, aa, zz);   ///// MAX antgain - combined gain
					Get_TX_SmallScale_antgain(channel[bs_idx][self_ms_idx].self_bs, bs_idx, sector_idx - 1, aa, zz);
					random_RSRP_antgain = Get_RSRP(bs_idx, self_ms_idx, (sector_idx - 1), zz, aa, 1);
					/////////////////////////////////////////////////////////////////
				}

				signal = bs_maxpower + random_RSRP_antgain - pathloss;
				//
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				//////////////////////////////////////////////////////////////////////////////////////////////////////////

				if ((bs_idx == self_bs_idx) && (sector_idx == self_sector_idx))
				{
					//
				}
				else
				{
					if (Configuration_Type == 0)  // config A
					{
						
					}
					else
					{
						interference += pow(10., (signal) / 10.);
					}
				}
			}
			
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



		//////////////////////////////////////////////////////////////////////////////////////////////////////////////

	}
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	else if (TYPE == 12)
	{
		
		for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
		{

			pathloss = channel[bs_idx][self_ms_idx].pathloss; //channel  pathloss´ // self_ms_idx   19BS  
			RMS_delay = channel[bs_idx][self_ms_idx].RMS_delay_spread;
			AOA_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOA;
			AOD_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOD;
			distance = channel[bs_idx][self_ms_idx].distance;
			//cout << distance << endl;

			pathloss = pathloss + incar_loss + Otoi_loss + channel[bs_idx][self_ms_idx].sigma_SF * randnum.n();

			channel[bs_idx][self_ms_idx].pathloss_final = pathloss;

			for (int sector_idx = 1; sector_idx < 4; sector_idx++)
			{

				/// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
				
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				//////////////////////////////////////   Antenna gain - NEW version //////////////////////////////////////
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				for (int a = 0; a < tilt_azimuth_angle_LCS_size; a++)
				{
					for (int z = 0; z < tilt_zenith_angle_LCS_size; z++)
					{
						antgain = Get_antgain(channel[bs_idx][self_ms_idx].self_bs, channel[bs_idx][self_ms_idx].self_ms, bs_idx, sector_idx-1, a, z);   ///// MAX antgain - combined gain
						Get_TX_SmallScale_antgain(channel[bs_idx][self_ms_idx].self_bs, bs_idx, sector_idx - 1, a, z);

						RSRP_antgain = Get_RSRP(bs_idx, self_ms_idx, (sector_idx - 1), z, a, 0);

						if (a == 0 && z == 0)  // first loop
						{
							MAX_RSRP_antgain = RSRP_antgain;

							azimuth_angle_idx_selected = selected_a;
							zenith_angle_idx_selected  = selected_z;
							panel_idx_selected         = selected_p;

							sector_a = a;
							sector_z = z;
						}
						else if (MAX_RSRP_antgain < RSRP_antgain)   // find max 
						{
							MAX_RSRP_antgain = RSRP_antgain;

							azimuth_angle_idx_selected = selected_a;
							zenith_angle_idx_selected  = selected_z;
							panel_idx_selected         = selected_p;

							sector_a = a;
							sector_z = z;
						}
						else
						{
							MAX_RSRP_antgain = MAX_RSRP_antgain;
						}
					}
				}

				signal = bs_maxpower + MAX_RSRP_antgain - pathloss;


				if (bs_idx == 0 && sector_idx == 1)
				{

					strongest_signal = signal;
					link_prev_MAX_RSRP = MAX_RSRP_antgain;
					link_prev_Random_RSRP = random_RSRP_antgain;

					self_bs_idx = bs_idx;
					self_sector_idx = sector_idx;
					link_pathloss = pathloss;
					link_coupling_loss = pathloss - antgain;
					//link_pathloss = pathloss - ms[self_ms_idx].LSPs[bs_idx](0);
					link_antgain = antgain;
					serving_bs = channel[bs_idx][self_ms_idx].self_bs;
					link_RMS_delay_spread = RMS_delay;
					link_AOA_spread = AOA_spread;
					link_AOD_spread = AOD_spread;
					link_distance = channel[bs_idx][self_ms_idx].distance;

					azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
					zenith_angle_idx_selected_for_interference  = zenith_angle_idx_selected;
					panel_idx_selected_for_interference         = panel_idx_selected;

					sector_azimuth_angle_idx = sector_a;
					sector_zenith_angle_idx = sector_z;

					_sector_in_control = self_bs_idx * 3 + (self_sector_idx - 1);


				}
				else if (signal > strongest_signal)
				{

					interference += pow(10., (strongest_signal - link_prev_MAX_RSRP + link_prev_Random_RSRP) / 10.);

					strongest_signal = signal;
					link_prev_MAX_RSRP = MAX_RSRP_antgain;
					link_prev_Random_RSRP = random_RSRP_antgain;

					self_bs_idx = bs_idx; // serving BS idx
					self_sector_idx = sector_idx;
					link_pathloss = pathloss;
					link_coupling_loss = pathloss - antgain;
					//link_pathloss = pathloss - ms[self_ms_idx].LSPs[bs_idx](0);
					link_antgain = antgain;
					serving_bs = channel[bs_idx][self_ms_idx].self_bs;
					link_RMS_delay_spread = RMS_delay;
					link_AOA_spread = AOA_spread;
					link_AOD_spread = AOD_spread;
					link_distance = channel[bs_idx][self_ms_idx].distance;

					azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
					zenith_angle_idx_selected_for_interference  = zenith_angle_idx_selected;
					panel_idx_selected_for_interference         = panel_idx_selected;

					sector_azimuth_angle_idx = sector_a;
					sector_zenith_angle_idx = sector_z;

					_sector_in_control = self_bs_idx * 3 + (self_sector_idx - 1);


				}
				else
				{
					interference += pow(10., (signal - MAX_RSRP_antgain + random_RSRP_antgain) / 10.);

				}
			}

			
		}

		//
		/////////////////////// Get interference ///////////////////////////////////////////////////////////////////////////////////////////////////////
		//
		/*
		for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
		{
			pathloss = channel[bs_idx][self_ms_idx].pathloss_final;

			for (int sector_idx = 1; sector_idx < 4; sector_idx++)
			{
				///////////////////////////////////////////////////////////////// random beam interference
				int aa = (int)(tilt_azimuth_angle_LCS_size * randnum.u());
				int zz = (int)(tilt_zenith_angle_LCS_size * randnum.u());


				random_antgain = Get_antgain(channel[bs_idx][self_ms_idx].self_bs, channel[bs_idx][self_ms_idx].self_ms, bs_idx, sector_idx - 1, aa, zz);   ///// MAX antgain - combined gain
				Get_TX_SmallScale_antgain(channel[bs_idx][self_ms_idx].self_bs, bs_idx, sector_idx - 1, aa, zz);

				random_RSRP_antgain = Get_RSRP(bs_idx, self_ms_idx, (sector_idx - 1), zz, aa, 1);
				/////////////////////////////////////////////////////////////////

				signal = bs_maxpower + random_RSRP_antgain - pathloss;


				if ((bs_idx == self_bs_idx) && (sector_idx == self_sector_idx))
				{

				}
				else
				{
					interference += pow(10., (signal) / 10.);
				}
			}

		}
		*/
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	}
	else if (TYPE == 13)
	{
		for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
		{

			pathloss = channel[bs_idx][self_ms_idx].pathloss; //channel  pathloss´ // self_ms_idx   19BS  
			RMS_delay = channel[bs_idx][self_ms_idx].RMS_delay_spread;
			AOA_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOA;
			AOD_spread = channel[bs_idx][self_ms_idx].circular_angle_spread_AOD;
			distance = channel[bs_idx][self_ms_idx].distance;
			//cout << distance << endl;

			//pathloss = pathloss + ms[self_ms_idx].LSPs[bs_idx](0) + incar_loss + Otoi_loss;   ////// Add Shadow Fading
			pathloss = pathloss + incar_loss + Otoi_loss + channel[bs_idx][self_ms_idx].sigma_SF * randnum.n();

			channel[bs_idx][self_ms_idx].pathloss_final = pathloss;

			for (int sector_idx = 1; sector_idx < 4; sector_idx++)
			{

				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				//////////////////////////////////////   Antenna gain - NEW version //////////////////////////////////////
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				
				for (int a = 0; a < tilt_azimuth_angle_LCS_size; a++)
				{
					for (int z = 0; z < tilt_zenith_angle_LCS_size; z++)
					{
						antgain = Get_antgain(channel[bs_idx][self_ms_idx].self_bs, channel[bs_idx][self_ms_idx].self_ms, bs_idx, sector_idx - 1, a, z);   ///// MAX antgain - combined gain
						Get_TX_SmallScale_antgain(channel[bs_idx][self_ms_idx].self_bs, bs_idx, sector_idx - 1, a, z);

						RSRP_antgain = Get_RSRP(bs_idx, self_ms_idx, (sector_idx - 1), z, a, 0);

						MAX_RSRP_antgain = RSRP_antgain;



						azimuth_angle_idx_selected = selected_a;
						zenith_angle_idx_selected = selected_z;
						panel_idx_selected = selected_p;

						sector_a = a;
						sector_z = z;


					}
				}
				
				signal = bs_maxpower + MAX_RSRP_antgain - pathloss;

				//*/
				//////////////////////////////////////////////////////////////////////////////////////////////////////////
				//////////////////////////////////////////////////////////////////////////////////////////////////////////

				if (bs_idx == 0 && sector_idx == 1)
				{

					strongest_signal = signal;
					link_prev_MAX_RSRP = MAX_RSRP_antgain;

					self_bs_idx = bs_idx;
					self_sector_idx = sector_idx;
					link_pathloss = pathloss;
					link_coupling_loss = pathloss - antgain;
					//link_pathloss = pathloss - ms[self_ms_idx].LSPs[bs_idx](0);
					link_antgain = antgain;
					serving_bs = channel[bs_idx][self_ms_idx].self_bs;
					link_RMS_delay_spread = RMS_delay;
					link_AOA_spread = AOA_spread;
					link_AOD_spread = AOD_spread;
					link_distance = channel[bs_idx][self_ms_idx].distance;

					azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
					zenith_angle_idx_selected_for_interference = zenith_angle_idx_selected;
					panel_idx_selected_for_interference = panel_idx_selected;

					sector_azimuth_angle_idx = sector_a;
					sector_zenith_angle_idx = sector_z;

					_sector_in_control = self_bs_idx * 3 + (self_sector_idx - 1);


				}
				else if (signal > strongest_signal)
				{

					interference += pow(10., (strongest_signal) / 10.);

					strongest_signal = signal;
					link_prev_MAX_RSRP = MAX_RSRP_antgain;

					self_bs_idx = bs_idx; // serving BS idx
					self_sector_idx = sector_idx;
					link_pathloss = pathloss;
					link_coupling_loss = pathloss - antgain;
					//link_pathloss = pathloss - ms[self_ms_idx].LSPs[bs_idx](0);
					link_antgain = antgain;
					serving_bs = channel[bs_idx][self_ms_idx].self_bs;
					link_RMS_delay_spread = RMS_delay;
					link_AOA_spread = AOA_spread;
					link_AOD_spread = AOD_spread;
					link_distance = channel[bs_idx][self_ms_idx].distance;

					azimuth_angle_idx_selected_for_interference = azimuth_angle_idx_selected;
					zenith_angle_idx_selected_for_interference = zenith_angle_idx_selected;
					panel_idx_selected_for_interference = panel_idx_selected;

					sector_azimuth_angle_idx = sector_a;
					sector_zenith_angle_idx = sector_z;

					_sector_in_control = self_bs_idx * 3 + (self_sector_idx - 1);


				}
				else
				{
					interference += pow(10., (signal) / 10.);

				}
			}


		}
	}
		
	str_signal = strongest_signal;
	signal = strongest_signal;
	interference = 10. * log10(interference);

}

void LINK::Get_adj_SECTORS() 
{
	double pathlosss;
	double antgainn;

	for (int idx = 0; idx < num_compute_coef; idx++)
	{
		if (idx == 0)
		{
			adj_sector[0] = _sector_in_control;
		}
		else
		{
			adj_sector[idx] = _sector_in_control + idx;

			if (_sector_in_control + idx > 56)
			{
				adj_sector[idx] = _sector_in_control - 2*idx;
			}
		}
	}
}


void LINK::UE_Initial_Setting(void) 
{


	//// Car penetration loss  //////////////////////////////////////////

  if (TYPE == 12) // Dense Urban 
  {
	  if (ms[self_ms_idx].Indoor == 1)   ///// Indoor
	  {
		  incar_loss = 0.;
	  }
	  else if (ms[self_ms_idx].Indoor == 0)                              ////// outdoor
	  {
		  incar_loss = 9. + 5. * randnum.n();
	  }
	  else
	  {
		  cout << "Channel Model Type ERROR!! - in_car_loss 1111 !!" << endl;
		  getchar();

	  }

  }
  else if (TYPE == 13) // Rural
  {
	  if (ms[self_ms_idx].Indoor == 1)   ///// Indoor
	  {
		  incar_loss = 0.;
	  }
	  else                              ////// outdoor
	  {
		  if (Configuration_Type == 2)     /////// Rural configuration C = 40% outdoor pedestrian, 20% outdoor incar
		  {
			  if (randnum.u() < (0.4/0.6))  //// Pedestrian
			  {
				  incar_loss = 0.;
			  }
			  else                   //// In Car
			  {
				  incar_loss = 9. + 5. * randnum.n();
			  }
		  }
		  else    /// 50% All outdoor
		  {
			  incar_loss = 9. + 5. * randnum.n();
		  }
	  }
  }
  else //// Indoor case
  {
    incar_loss = 0.;
  }


  ///////////////////////////// Building penetration loss /////////////////////////////////

  double glass_L    = 2 + 0.2 * Frequency / (1000000000.);      ///// Standard multi-pane glass , Frequency = GHz
  double IRRglass_L = 23 + 0.3 * Frequency / (1000000000.);     ///// Infrared Reflective(IRR) glass , Frequency = GHz
  double concrete_L = 5 + 4 * Frequency / (1000000000.);        ///// Concrete glass , Frequency = GHz
  double wood_L     = 4.85 + 0.12 * Frequency / (1000000000.);  ///// Wood glass , Frequency = GHz

  double indoor_L;

  if (TYPE == 12) // Dense Urban UMa
  {
	  //cout << "ms[self_ms_idx].Indoor = " << ms[self_ms_idx].Indoor << endl;
	  //getchar();


	  if (ms[self_ms_idx].Indoor == 0)   ///// Outdoor
	  {
		  Otoi_loss = 0;
	  }
	  else                               /////// Indoor
	  {
		  if (Channel_Model_Type == 1)   ///// Model B
		  {
			  if (randnum.u() > 0.2) //// 80% Low Loss  O2I
			  {
				  /////// Low-loss model

				  Otoi_loss = 5 - 10 * log10(0.3 * pow(10, -1 * (glass_L / 10)) + 0.7 * pow(10, -1 * (concrete_L / 10)));
				  indoor_L = 0.5 * MIN((25 * randnum.u()), (25 * randnum.u()));

				  Otoi_loss = Otoi_loss + indoor_L + 4.4 * randnum.n();

			  }
			  else           ////// 20& High Loss O2I
			  {
				  /////// High-loss model

				  Otoi_loss = 5 - 10 * log10(0.7 * pow(10, -1 * (IRRglass_L / 10)) + 0.3 * pow(10, -1 * (concrete_L / 10)));
				  indoor_L = 0.5 * MIN((25 * randnum.u()), (25 * randnum.u()));

				  Otoi_loss = Otoi_loss + indoor_L + 6.5 * randnum.n();
			  }
		  }
		  else if (Channel_Model_Type == 0)  //// Model A 
		  {
			  if (Frequency > 6000000000.)  //// above 6GHz
			  {
				  if (randnum.u() > 0.2) //// 80% Low Loss  O2I
				  {
					  /////// Low-loss model

					  Otoi_loss = 5 - 10 * log10(0.3 * pow(10, -1 * (glass_L / 10)) + 0.7 * pow(10, -1 * (concrete_L / 10)));
					  indoor_L = 0.5 * MIN((25 * randnum.u()), (25 * randnum.u()));

					  Otoi_loss = Otoi_loss + indoor_L + 4.4 * randnum.n();
				  }
				  else
				  {
					  /////// High-loss model

					  Otoi_loss = 5 - 10 * log10(0.7 * pow(10, -1 * (IRRglass_L / 10)) + 0.3 * pow(10, -1 * (concrete_L / 10)));
					  indoor_L = 0.5 * MIN((25 * randnum.u()), (25 * randnum.u()));

					  Otoi_loss = Otoi_loss + indoor_L + 6.5 * randnum.n();
				  }
			  }
			  else                         //// below 6GHz
			  {
				  Otoi_loss = 20.;
				  indoor_L = 0.5 * ms[self_ms_idx].ms_d_in;

				  Otoi_loss = Otoi_loss + indoor_L;


			  }
		  }
		  else
		  {
			  cout << "Channel Model Type ERROR!! - Otoi Loss" << endl;
		  }
	  }
  }
  else if (TYPE == 13) // Rural
  {
	  if (ms[self_ms_idx].Indoor == 0)   ///// Outdoor
	  {
		  Otoi_loss = 0;
	  }
	  else                               /////// Indoor
	  {
		  if (Channel_Model_Type == 1)   ///// Model B
		  {
			  /////// 100% Low-loss model
			  Otoi_loss = 5 - 10 * log10(0.3 * pow(10, -1 * (glass_L / 10)) + 0.7 * pow(10, -1 * (concrete_L / 10)));
			  indoor_L = 0.5 * MIN((10 * randnum.u()), (10 * randnum.u()));

			  Otoi_loss = Otoi_loss + indoor_L + 4.4 * randnum.n();

		  }
		  else if (Channel_Model_Type == 0)  //// Model A 
		  {
			  if (Frequency > 6000000000)  //// above 6GHz
			  {
				  /////// 100% Low-loss model
				  Otoi_loss = 5 - 10 * log10(0.3 * pow(10, -1 * (glass_L / 10)) + 0.7 * pow(10, -1 * (concrete_L / 10)));
				  indoor_L = 0.5 * MIN((10 * randnum.u()), (10 * randnum.u()));

				  Otoi_loss = Otoi_loss + indoor_L + 4.4 * randnum.n();
			  }
			  else                         //// below 6GHz
			  {
				  Otoi_loss = 10;
				  indoor_L = 0.5 * (10 * randnum.u());

				  Otoi_loss = Otoi_loss + indoor_L;
			  }
		  }
		  else
		  {
			  cout << "Channel Model Type ERROR!! - Otoi Loss" << endl;
		  }
	  }
  }
  else   ///// Indoor case
  {
	  Otoi_loss = 0.;
  }


  // initial setting
  _throughput = 0 ;
  CQI_offset = 0;
  num_added = 0;
  num_re_tx =    0;
  ACK = true;

  //H_m = NULL;
  //HI_m = NULL;
}


double LINK::Get_angle(LOCATION interferer, LOCATION victim, LOCATION interfere_rx  )
{
	double angle = 0;
	double vector1_x, vector1_y, vector2_x, vector2_y;
	double acos_input = 0;
	

	vector1_x = victim.x - interferer.x;  /// BS->MS vector
	vector1_y = victim.y - interferer.y;
	vector2_x = interfere_rx.x - interferer.x;  /// Boresight vector
	vector2_y = interfere_rx.y - interferer.y;
	acos_input = (vector1_x*vector2_x + vector1_y*vector2_y)
		/ (sqrt(vector1_x*vector1_x + vector1_y*vector1_y)*sqrt(vector2_x*vector2_x + vector2_y*vector2_y));

	if (acos_input >= 1)
	{
		angle = 0;
	}
	else
	{
		angle = acos(acos_input);

		if ((victim.y-interfere_rx.y)<0.)
		{
			angle = -angle;
		}

	}

	return angle * 180. / pi;

}


double LINK::Get_antgain(LOCATION interferer,LOCATION victim, int _bs_idx, int sector_idx, int tilt_a_idx, int tilt_z_idx)  ////// LOS gain BS
{
	double h_angle_pi = channel[_bs_idx][self_ms_idx].LOS_AOD_GCS * (pi / 180.);  //// pi in GCS
	double v_angle_theta = channel[_bs_idx][self_ms_idx].LOS_ZOD_GCS * (pi / 180.);  ///// theta in GCS

	double F_theta_GCS_P1 = 0;
	double F_pi_GCS_P1 = 0;
	double F_theta_GCS_P2 = 0;
	double F_pi_GCS_P2 = 0;

	int _sector_idx = sector_idx;


	complex <double> F_tx_theta = (0, 0);
	complex <double> F_tx_pi = (0, 0);

	double combined_antenna_gain = Get_BS_antenna_pattern(v_angle_theta, h_angle_pi, _bs_idx, _sector_idx, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

	Get_BS_antenna_field_pattern(interferer, _bs_idx, _sector_idx, tilt_z_idx, tilt_a_idx, v_angle_theta, h_angle_pi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_tx_theta, F_tx_pi);

	TransmitterAntennaGainXLOS_theta = F_tx_theta;
	TransmitterAntennaGainXLOS_pi = F_tx_pi;

	return combined_antenna_gain;
}



void LINK::Get_TX_SmallScale_antgain(LOCATION interferer, int _bs_idx, int sector_idx, int tilt_a_idx, int tilt_z_idx)
{
	if (TYPE == 11)   /// Indoor
	{
		SmallScale_TX_AntennaGainXLOS_theta.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_TX_AntennaGainXLOS_pi.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);

		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < MAX_NUM_RAYS; j++)
			{
				SmallScale_TX_AntennaGainXLOS_theta(i, j) = 0.;
				SmallScale_TX_AntennaGainXLOS_pi(i, j) = 0.;
			}
		}


		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < channel[_bs_idx][self_ms_idx].NUM_RAY_per_ClusterNUM[i]; j++)
			{

				double h_angle_pi    = channel[_bs_idx][self_ms_idx].AOD[i] + channel[_bs_idx][self_ms_idx].cluster_ASD * channel[_bs_idx][self_ms_idx].offset_angle_rand_coupling[i][j];
				double v_angle_theta = channel[_bs_idx][self_ms_idx].ZOD[i] + (3. / 8.) * pow(10, channel[_bs_idx][self_ms_idx].mu_ZSD) * channel[_bs_idx][self_ms_idx].offset_angle_rand_coupling[i][j];

				Transform_angle_minus_180_to_plus_180(h_angle_pi);
				Transform_angle_0_to_plus_180(v_angle_theta);

				h_angle_pi = h_angle_pi * (pi / 180.);
				v_angle_theta = v_angle_theta * (pi / 180.);

				double F_theta_GCS_P1 = 0;
				double F_pi_GCS_P1 = 0;
				double F_theta_GCS_P2 = 0;
				double F_pi_GCS_P2 = 0;

				complex <double> F_tx_theta = (0, 0);
				complex <double> F_tx_pi = (0, 0);

				double combined_antenna_gain = Get_BS_antenna_pattern(v_angle_theta, h_angle_pi, _bs_idx, sector_idx, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

				Get_BS_antenna_field_pattern(interferer, _bs_idx, sector_idx, tilt_z_idx, tilt_a_idx, v_angle_theta, h_angle_pi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_tx_theta, F_tx_pi);


				SmallScale_TX_AntennaGainXLOS_theta(i, j) = F_tx_theta;
				SmallScale_TX_AntennaGainXLOS_pi(i, j) = F_tx_pi;
			}
		}
	}
	else if (TYPE == 12 || TYPE == 13)   ////// Dense Urban & Rural
	{
		SmallScale_TX_AntennaGainXLOS_theta.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_TX_AntennaGainXLOS_pi.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);

		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < MAX_NUM_RAYS; j++)
			{
				SmallScale_TX_AntennaGainXLOS_theta(i, j) = 0.;
				SmallScale_TX_AntennaGainXLOS_pi(i, j) = 0.;
			}
		}


		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < channel[_bs_idx][self_ms_idx].NUM_RAY_per_ClusterNUM[i]; j++)
			{
				double h_angle_pi    = channel[_bs_idx][self_ms_idx].AOD[i] + channel[_bs_idx][self_ms_idx].cluster_ASD * channel[_bs_idx][self_ms_idx].offset_angle_rand_coupling[i][j];
				double v_angle_theta = channel[_bs_idx][self_ms_idx].ZOD[i] + (3. / 8.) * pow(10, channel[_bs_idx][self_ms_idx].mu_ZSD) * channel[_bs_idx][self_ms_idx].offset_angle_rand_coupling[i][j];

				Transform_angle_minus_180_to_plus_180(h_angle_pi);
				Transform_angle_0_to_plus_180(v_angle_theta);

				h_angle_pi = h_angle_pi * (pi / 180.);
				v_angle_theta = v_angle_theta * (pi / 180.);

				double F_theta_GCS_P1 = 0;
				double F_pi_GCS_P1 = 0;
				double F_theta_GCS_P2 = 0;
				double F_pi_GCS_P2 = 0;

				complex <double> F_tx_theta = (0, 0);
				complex <double> F_tx_pi = (0, 0);

				double combined_antenna_gain = Get_BS_antenna_pattern(v_angle_theta, h_angle_pi, _bs_idx, sector_idx, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

				Get_BS_antenna_field_pattern(interferer, _bs_idx, sector_idx, tilt_z_idx, tilt_a_idx, v_angle_theta, h_angle_pi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_tx_theta, F_tx_pi);

				SmallScale_TX_AntennaGainXLOS_theta(i,j) = F_tx_theta;
				SmallScale_TX_AntennaGainXLOS_pi(i,j) = F_tx_pi;

			}
		}
	}

	else
	{
		cout << "TX small scale antgain ERROR!" << endl;
		getchar();
	}

}

void LINK::Get_RX_SmallScale_antgain(int M, int N, int P, int _bs_idx, int sector_idx, int tilt_z_idx, int tilt_a_idx, int ue_interference_index)
{
	int ms_idx = self_ms_idx;

	if (TYPE == 11)   /// Indoor
	{
		SmallScale_RX_AntennaGainXLOS_theta.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_RX_AntennaGainXLOS_pi.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_RX_AntennaGainXLOS_theta_panel_2.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_RX_AntennaGainXLOS_pi_panel_2.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);

		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < MAX_NUM_RAYS; j++)
			{
				SmallScale_RX_AntennaGainXLOS_theta(i, j) = 0.;
				SmallScale_RX_AntennaGainXLOS_pi(i, j) = 0.;
				SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) = 0.;
				SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j) = 0.;
			}
		}


		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < channel[_bs_idx][self_ms_idx].NUM_RAY_per_ClusterNUM[i]; j++)
			{
				double h_angle_pi = channel[_bs_idx][self_ms_idx].AOA[i] + channel[_bs_idx][self_ms_idx].cluster_ASA * channel[_bs_idx][self_ms_idx].offset_angle[i][j];
				double v_angle_theta = channel[_bs_idx][self_ms_idx].ZOA[i] + channel[_bs_idx][self_ms_idx].cluster_ZSA * channel[_bs_idx][self_ms_idx].offset_angle[i][j];

				Transform_angle_minus_180_to_plus_180(h_angle_pi);
				Transform_angle_0_to_plus_180(v_angle_theta);


				h_angle_pi = h_angle_pi * (pi / 180.);
				v_angle_theta = v_angle_theta * (pi / 180.);

				double F_theta_GCS_P1 = 0;
				double F_pi_GCS_P1 = 0;
				double F_theta_GCS_P2 = 0;
				double F_pi_GCS_P2 = 0;

				complex <double> F_rx_theta = (0, 0);
				complex <double> F_rx_pi = (0, 0);
				complex <double> F_rx_theta_2 = (0, 0);
				complex <double> F_rx_pi_2 = (0, 0);

				double combined_antenna_gain;


				if (ue_antenna_element_gain == 0) // UE omni-antenna case
				{
					combined_antenna_gain = 0;

					if (P == 0)
					{
						SmallScale_RX_AntennaGainXLOS_theta(i, j) = 1.;
						SmallScale_RX_AntennaGainXLOS_pi(i, j) = 0.;
					}
					else
					{
						SmallScale_RX_AntennaGainXLOS_theta(i, j) = 0.;
						SmallScale_RX_AntennaGainXLOS_pi(i, j) = 1.;
					}
				}
				else
				{

					combined_antenna_gain = Get_UE_antenna_pattern(P, v_angle_theta, h_angle_pi, ms_idx, sector_idx, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

					Get_UE_antenna_field_pattern(channel[_bs_idx][self_ms_idx].self_ms, M, N, P, ms_idx, sector_idx, tilt_z_idx, tilt_a_idx, v_angle_theta, h_angle_pi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_rx_theta, F_rx_pi, F_rx_theta_2, F_rx_pi_2);

					SmallScale_RX_AntennaGainXLOS_theta(i, j) = F_rx_theta;
					SmallScale_RX_AntennaGainXLOS_pi(i, j) = F_rx_pi;

					SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) = F_rx_theta_2;
					SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j) = F_rx_pi_2;
				}


			}
		}
	}
	else if (TYPE == 12 || TYPE == 13)   ////// Dense Urban & Rural
	{

		SmallScale_RX_AntennaGainXLOS_theta.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_RX_AntennaGainXLOS_pi.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_RX_AntennaGainXLOS_theta_panel_2.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);
		SmallScale_RX_AntennaGainXLOS_pi_panel_2.resize(channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff, MAX_NUM_RAYS);

		// initialize
		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < MAX_NUM_RAYS; j++)
			{
				SmallScale_RX_AntennaGainXLOS_theta(i, j) = 0.;
				SmallScale_RX_AntennaGainXLOS_pi(i, j) = 0.;
				SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) = 0.;
				SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j) = 0.;
			}
		}

		//
		for (int i = 0; i < channel[_bs_idx][self_ms_idx].NUM_PATH_for_channelcoeff; i++)
		{
			for (int j = 0; j < channel[_bs_idx][self_ms_idx].NUM_RAY_per_ClusterNUM[i]; j++)
			{
				double h_angle_pi = channel[_bs_idx][self_ms_idx].AOA[i] + channel[_bs_idx][self_ms_idx].cluster_ASA * channel[_bs_idx][self_ms_idx].offset_angle[i][j];
				double v_angle_theta = channel[_bs_idx][self_ms_idx].ZOA[i] + channel[_bs_idx][self_ms_idx].cluster_ZSA * channel[_bs_idx][self_ms_idx].offset_angle[i][j];

				Transform_angle_minus_180_to_plus_180(h_angle_pi);
				Transform_angle_0_to_plus_180(v_angle_theta);

				h_angle_pi = h_angle_pi * (pi / 180.);
				v_angle_theta = v_angle_theta * (pi / 180.);

				double F_theta_GCS_P1 = 0;
				double F_pi_GCS_P1 = 0;
				double F_theta_GCS_P2 = 0;
				double F_pi_GCS_P2 = 0;

				complex <double> F_rx_theta = (0, 0);
				complex <double> F_rx_pi = (0, 0);
				complex <double> F_rx_theta_2 = (0, 0);
				complex <double> F_rx_pi_2 = (0, 0);

				double combined_antenna_gain;

				if (ue_antenna_element_gain == 0) // UE omni-antenna case
				{
					combined_antenna_gain = 0;

					/// UE antenna = omni case
					if (P == 0)
					{
						SmallScale_RX_AntennaGainXLOS_theta(i, j) = 1.;
						SmallScale_RX_AntennaGainXLOS_pi(i, j) = 0.;
					}
					else
					{
						SmallScale_RX_AntennaGainXLOS_theta(i, j) = 0.;
						SmallScale_RX_AntennaGainXLOS_pi(i, j) = 1.;
					}
					
					
				}
				else  // UE directional antenna case
				{

					combined_antenna_gain = Get_UE_antenna_pattern(P, v_angle_theta, h_angle_pi, ms_idx, sector_idx, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

					Get_UE_antenna_field_pattern(channel[_bs_idx][self_ms_idx].self_ms, M, N, P, ms_idx, sector_idx, tilt_z_idx, tilt_a_idx, v_angle_theta, h_angle_pi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_rx_theta, F_rx_pi, F_rx_theta_2, F_rx_pi_2);

					SmallScale_RX_AntennaGainXLOS_theta(i, j) = F_rx_theta;
					SmallScale_RX_AntennaGainXLOS_pi(i, j) = F_rx_pi;

					SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) = F_rx_theta_2;
					SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j) = F_rx_pi_2;
				}
			}
		}
	}

	else
	{
		cout << "RX small scale antgain ERROR!" << endl;
		getchar();
	}
}


double LINK::Get_RSRP(int _bs_idx, int _ms_idx, int sec_number, int sec_z_idx, int sec_a_idx, int ue_interference)
{

	// ue_interference = 0 -> find max ue beam & RSRP
	// ue_interference = 1 -> for interference calculation, ue beam already selected

	complex<double> Big_PI_LOS             (0. , (360. * randnum.u() - 180.0)* (pi / 180.0));

	double K_linear = channel[_bs_idx][_ms_idx].K_linear;

	double XPR = pow(10.0, (channel[_bs_idx][_ms_idx].XPR) / 10.0);

	double alpha = 0;
	double alpha_panel_2 = 0;
	double alpha_zero = 0.;
	double alpha_zero_panel_2 = 0.;
	complex <double> alpha_zero_temp = 0.;
	complex <double> alpha_zero_temp_panel_2 = 0.;
	double alpha_nmup = 0.;
	double alpha_nmup_panel_2 = 0.;
	complex <double> alpha_nmup_temp = 0.;
	complex <double> alpha_nmup_temp_panel_2 = 0.;


	double UE_antenna_gain;

	double kappa;
	double _1_over_sqrt_K;


	if (ue_antenna_element_gain == 0)  //// 1 to 1 mapping, NOT USE ue beam, ue PORT
	{
		int M = MS_M;
		int N = MS_N;
		int P = MS_P;

		for (int m = 0; m < M; m++)
		{
			for (int n = 0; n < N; n++)
			{
				for (int p = 0; p < P; p++)
				{

					alpha_zero = 0;
					alpha_nmup = 0;

					UE_antenna_gain = Get_MS_antgain(m, n, p, _bs_idx, 0, 0, 0, 0);   ///// MAX antgain - combined gain;
					Get_RX_SmallScale_antgain(m, n, p, _bs_idx, 0, 0, 0, 0);

					//if (p == 0)  // polar 1
					//{
					if (channel[_bs_idx][_ms_idx].Propagation == LOS_propagation)
					{
						alpha_zero_temp = sqrt(K_linear / (K_linear + 1)) * (ReceiverAntennaGainXLOS_theta * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_theta - ReceiverAntennaGainXLOS_pi * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_pi);

						alpha_zero = abs(alpha_zero_temp)*abs(alpha_zero_temp);
					}


					for (int i = 0; i < channel[_bs_idx][_ms_idx].NUM_PATH_for_channelcoeff; i++)
					{
						for (int j = 0; j < channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i]; j++)
						{
							kappa = channel[_bs_idx][_ms_idx].kappa[i][j];
							_1_over_sqrt_K = 1.0 / sqrt(kappa);

							complex<double> Big_pi_NLOS_thetatheta(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
							complex<double> Big_pi_NLOS_thetapi(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
							complex<double> Big_pi_NLOS_pitheta(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
							complex<double> Big_pi_NLOS_pipi(0, (360. * randnum.u() - 180.0)*(pi / 180.0));

							alpha_nmup_temp = sqrt(channel[_bs_idx][_ms_idx].power[i] / (channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i] * (K_linear + 1))) * (
								(SmallScale_RX_AntennaGainXLOS_theta(i, j) * exp(Big_pi_NLOS_thetatheta) + SmallScale_RX_AntennaGainXLOS_pi(i, j)* _1_over_sqrt_K *exp(Big_pi_NLOS_pitheta)) * SmallScale_TX_AntennaGainXLOS_theta(i, j) +
								(SmallScale_RX_AntennaGainXLOS_theta(i, j) * _1_over_sqrt_K * exp(Big_pi_NLOS_thetapi) + SmallScale_RX_AntennaGainXLOS_pi(i, j)*exp(Big_pi_NLOS_pipi)) * SmallScale_TX_AntennaGainXLOS_pi(i, j)
								);

							alpha_nmup = alpha_nmup + (abs(alpha_nmup_temp) * abs(alpha_nmup_temp));
						}
					}
					alpha += alpha_zero + alpha_nmup;
				}
			}
		}

		channel[_bs_idx][_ms_idx].signal_RSRP_gain[sec_number][sec_z_idx][sec_a_idx][0][0][0] = alpha / (double)(M*N*P);

		selected_a = 0;
		selected_z = 0;
		selected_p = 0;

		double RSRP_antenna_gain = (alpha) / (M*N*P);

		return 10 * log10(RSRP_antenna_gain);
			
	}

	///// UE beamforming 
	else  ///// UE beamforming 
	{
		if (ue_interference == 1)  /// for interference calculation, ue beam already selected
		{
			int M = MS_Mp;
			int N = MS_Np;
			int P = MS_P;
			double MAX_alpha;

			alpha = 0;
			alpha_panel_2 = 0;


			for (int m = 0; m < M; m++)
			{
				for (int n = 0; n < N; n++)
				{
					for (int polar = 0; polar < P; polar++)
					{
						alpha_zero = 0;
						alpha_nmup = 0;
						alpha_zero_panel_2 = 0;
						alpha_nmup_panel_2 = 0;

						UE_antenna_gain = Get_MS_antgain(m, n, polar, _bs_idx, 0, zenith_angle_idx_selected_for_interference, azimuth_angle_idx_selected_for_interference, ue_interference);   ///// MAX antgain - combined gain;
						Get_RX_SmallScale_antgain(m, n, polar, _bs_idx, 0, zenith_angle_idx_selected_for_interference, azimuth_angle_idx_selected_for_interference, ue_interference);



						if (channel[_bs_idx][_ms_idx].Propagation == LOS_propagation)
						{
							//complex<double> Big_PI_LOS(0., (360. * randnum.u() - 180.0)* (pi / 180.0));

							// panel 1
							alpha_zero_temp = sqrt(K_linear / (K_linear + 1)) * (ReceiverAntennaGainXLOS_theta * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_theta - ReceiverAntennaGainXLOS_pi * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_pi);
							alpha_zero = abs(alpha_zero_temp)*abs(alpha_zero_temp);

							// panel 2
							alpha_zero_temp_panel_2 = sqrt(K_linear / (K_linear + 1)) * (ReceiverAntennaGainXLOS_theta_panel_2 * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_theta - ReceiverAntennaGainXLOS_pi_panel_2 * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_pi);
							alpha_zero_panel_2 = abs(alpha_zero_temp_panel_2)*abs(alpha_zero_temp_panel_2);
						}


						for (int i = 0; i < channel[_bs_idx][_ms_idx].NUM_PATH_for_channelcoeff; i++)
						{
							for (int j = 0; j < channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i]; j++)
							{
								kappa = channel[_bs_idx][_ms_idx].kappa[i][j];
								_1_over_sqrt_K = 1.0 / sqrt(kappa);

								complex<double> Big_pi_NLOS_thetatheta(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
								complex<double> Big_pi_NLOS_thetapi(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
								complex<double> Big_pi_NLOS_pitheta(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
								complex<double> Big_pi_NLOS_pipi(0, (360. * randnum.u() - 180.0)*(pi / 180.0));

								// panel 1
								alpha_nmup_temp = sqrt(channel[_bs_idx][_ms_idx].power[i] / (channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i] * (K_linear + 1))) * (
									(SmallScale_RX_AntennaGainXLOS_theta(i, j) * exp(Big_pi_NLOS_thetatheta) + SmallScale_RX_AntennaGainXLOS_pi(i, j)* _1_over_sqrt_K *exp(Big_pi_NLOS_pitheta)) * SmallScale_TX_AntennaGainXLOS_theta(i, j) +
									(SmallScale_RX_AntennaGainXLOS_theta(i, j) * _1_over_sqrt_K * exp(Big_pi_NLOS_thetapi) + SmallScale_RX_AntennaGainXLOS_pi(i, j)*exp(Big_pi_NLOS_pipi)) * SmallScale_TX_AntennaGainXLOS_pi(i, j)
									);

								alpha_nmup = alpha_nmup + (abs(alpha_nmup_temp) * abs(alpha_nmup_temp));

								/// panel 2
								alpha_nmup_temp_panel_2 = sqrt(channel[_bs_idx][_ms_idx].power[i] / (channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i] * (K_linear + 1))) * (
									(SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) * exp(Big_pi_NLOS_thetatheta) + SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j)* _1_over_sqrt_K *exp(Big_pi_NLOS_pitheta)) * SmallScale_TX_AntennaGainXLOS_theta(i, j) +
									(SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) * _1_over_sqrt_K * exp(Big_pi_NLOS_thetapi) + SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j)*exp(Big_pi_NLOS_pipi)) * SmallScale_TX_AntennaGainXLOS_pi(i, j)
									);

								alpha_nmup_panel_2 = alpha_nmup_panel_2 + (abs(alpha_nmup_temp_panel_2) * abs(alpha_nmup_temp_panel_2));

							}
						}
						alpha += alpha_zero + alpha_nmup;
						alpha_panel_2 += alpha_zero_panel_2 + alpha_nmup_panel_2;
					}
				}
				


			}

			double alpha_interference;

			if (panel_idx_selected_for_interference == 0)
			{
				alpha_interference = alpha;
			}
			else if (panel_idx_selected_for_interference == 1)
			{
				alpha_interference = alpha_panel_2;
			}

			double RSRP_antenna_gain = (alpha_interference) / (M*N*P);

			return 10 * log10(RSRP_antenna_gain);
		
		}
		else  /// find max ue beam selection
		{
			int M = MS_Mp;
			int N = MS_Np;
			int P = MS_P;
			double MAX_alpha;

			for (int z = 0; z < ue_tilt_zenith_angle_LCS_size; z++)
			{
				for (int a = 0; a < ue_tilt_azimuth_angle_LCS_size; a++)
				{
					alpha = 0;
					alpha_panel_2 = 0;

					for (int m = 0; m < M; m++)
					{
						for (int n = 0; n < N; n++)
						{
							for (int polar = 0; polar < P; polar++)
							{
								alpha_zero = 0;
								alpha_nmup = 0;
								alpha_zero_panel_2 = 0;
								alpha_nmup_panel_2 = 0;

								UE_antenna_gain = Get_MS_antgain(m, n, polar, _bs_idx, 0, z, a, ue_interference);   ///// MAX antgain - combined gain;
								Get_RX_SmallScale_antgain(m, n, polar, _bs_idx, 0, z, a, ue_interference);



								if (channel[_bs_idx][_ms_idx].Propagation == LOS_propagation)
								{
									//complex<double> Big_PI_LOS(0., (360. * randnum.u() - 180.0)* (pi / 180.0));

									// panel 1
									alpha_zero_temp = sqrt(K_linear / (K_linear + 1)) * (ReceiverAntennaGainXLOS_theta * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_theta - ReceiverAntennaGainXLOS_pi * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_pi);
									alpha_zero = abs(alpha_zero_temp)*abs(alpha_zero_temp);

									// panel 2
									alpha_zero_temp_panel_2 = sqrt(K_linear / (K_linear + 1)) * (ReceiverAntennaGainXLOS_theta_panel_2 * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_theta - ReceiverAntennaGainXLOS_pi_panel_2 * exp(Big_PI_LOS) * TransmitterAntennaGainXLOS_pi);
									alpha_zero_panel_2 = abs(alpha_zero_temp_panel_2)*abs(alpha_zero_temp_panel_2);
								}


								for (int i = 0; i < channel[_bs_idx][_ms_idx].NUM_PATH_for_channelcoeff; i++)
								{
									for (int j = 0; j < channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i]; j++)
									{
										kappa = channel[_bs_idx][_ms_idx].kappa[i][j];
										_1_over_sqrt_K = 1.0 / sqrt(kappa);

										complex<double> Big_pi_NLOS_thetatheta(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
										complex<double> Big_pi_NLOS_thetapi(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
										complex<double> Big_pi_NLOS_pitheta(0, (360. * randnum.u() - 180.0)*(pi / 180.0));
										complex<double> Big_pi_NLOS_pipi(0, (360. * randnum.u() - 180.0)*(pi / 180.0));

										// panel 1
										alpha_nmup_temp = sqrt(channel[_bs_idx][_ms_idx].power[i] / (channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i] * (K_linear + 1))) * (
											(SmallScale_RX_AntennaGainXLOS_theta(i, j) * exp(Big_pi_NLOS_thetatheta) + SmallScale_RX_AntennaGainXLOS_pi(i, j)* _1_over_sqrt_K *exp(Big_pi_NLOS_pitheta)) * SmallScale_TX_AntennaGainXLOS_theta(i, j) +
											(SmallScale_RX_AntennaGainXLOS_theta(i, j) * _1_over_sqrt_K * exp(Big_pi_NLOS_thetapi) + SmallScale_RX_AntennaGainXLOS_pi(i, j)*exp(Big_pi_NLOS_pipi)) * SmallScale_TX_AntennaGainXLOS_pi(i, j)
											);

										alpha_nmup = alpha_nmup + (abs(alpha_nmup_temp) * abs(alpha_nmup_temp));

										/// panel 2
										alpha_nmup_temp_panel_2 = sqrt(channel[_bs_idx][_ms_idx].power[i] / (channel[_bs_idx][_ms_idx].NUM_RAY_per_ClusterNUM[i] * (K_linear + 1))) * (
											(SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) * exp(Big_pi_NLOS_thetatheta) + SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j)* _1_over_sqrt_K *exp(Big_pi_NLOS_pitheta)) * SmallScale_TX_AntennaGainXLOS_theta(i, j) +
											(SmallScale_RX_AntennaGainXLOS_theta_panel_2(i, j) * _1_over_sqrt_K * exp(Big_pi_NLOS_thetapi) + SmallScale_RX_AntennaGainXLOS_pi_panel_2(i, j)*exp(Big_pi_NLOS_pipi)) * SmallScale_TX_AntennaGainXLOS_pi(i, j)
											);

										alpha_nmup_panel_2 = alpha_nmup_panel_2 + (abs(alpha_nmup_temp_panel_2) * abs(alpha_nmup_temp_panel_2));

									}
								}
								alpha += alpha_zero + alpha_nmup;
								alpha_panel_2 += alpha_zero_panel_2 + alpha_nmup_panel_2;
							}
						}
					}



					channel[_bs_idx][_ms_idx].signal_RSRP_gain[sec_number][sec_z_idx][sec_a_idx][z][a][0] = alpha / (double)(M*N*P);          //[sec_idx] [sec_zenith][sec_azimuth][ue_zenith_idx][ue_azimuth_idx][pannel];
					channel[_bs_idx][_ms_idx].signal_RSRP_gain[sec_number][sec_z_idx][sec_a_idx][z][a][1] = alpha_panel_2 / (double)(M*N*P);  //[sec_idx] [sec_zenith][sec_azimuth][ue_zenith_idx][ue_azimuth_idx][pannel];


					if (a == 0 && z == 0)  // first loop
					{
						if (alpha > alpha_panel_2)
						{
							MAX_alpha = alpha;

							selected_a  = a;
							selected_z  = z;
							selected_p  = 0;
						}
						else
						{
							MAX_alpha = alpha_panel_2;

							selected_a  = a;
							selected_z  = z;
							selected_p  = 1;
						}
					}
					else if ((MAX_alpha < alpha) || (MAX_alpha < alpha_panel_2))
					{
						if (alpha > alpha_panel_2)
						{
							MAX_alpha = alpha;

							selected_a = a;
							selected_z = z;
							selected_p = 0;
						}
						else
						{
							MAX_alpha = alpha_panel_2;

							selected_a = a;
							selected_z = z;
							selected_p = 1;
						}
					}
					else
					{
						MAX_alpha = MAX_alpha;

						selected_a = selected_a;
						selected_z = selected_z;
						selected_p = selected_p;
					}
				}
			}

			double RSRP_antenna_gain = (MAX_alpha) / (M*N*P);


			return 10 * log10(RSRP_antenna_gain);
		}
	}
}

double Get_LCS_theta(double alpha, double beta, double gamma, double GCS_theta, double GCS_pi)
{
	return acosl( cos(beta)*cos(gamma)*cos(GCS_theta) + (sin(beta)*cos(gamma)*cos(GCS_pi-alpha) - sin(gamma)*sin(GCS_pi-alpha))*sin(GCS_theta));
}

double Get_LCS_pi(double alpha, double beta, double gamma, double GCS_theta, double GCS_pi)
{

	// arg(x+iy) = atan2(y,x)


	double real;
	double imag;

	real = (cos(beta)*sin(GCS_theta)*cos(GCS_pi - alpha) - sin(beta)*cos(GCS_theta));
	imag = (cos(beta)*sin(gamma)*cos(GCS_theta) + (sin(beta)*sin(gamma)*cos(GCS_pi - alpha) + cos(gamma)*sin(GCS_pi - alpha))*sin(GCS_theta));

	return atan2l(imag,real);

}


MatrixXd Get_distance_angular(double a, double b, double c, double x, double y, double z)
{
	///// TR 36.873 page 9

	MatrixXd Rd(3, 1);

	Rd(0, 0) = cos(a)*cos(b) * x + cos(a)*sin(b)*sin(c) - sin(a)*cos(c) * y + cos(a)*sin(b)*cos(c) + sin(a)*sin(c) * z;
	Rd(1, 0) = sin(a)*cos(b) * x + sin(a)*sin(b)*sin(c) + cos(a)*cos(c) * y + sin(a)*sin(b)*cos(c) - cos(a)*sin(c) * z;
	Rd(2, 0) = -sin(b)		 * x + cos(b)*sin(c)					    * y + cos(b)*cos(c)						   * z;

	return Rd;
}


double LINK::Get_MS_antgain(int M, int N, int P, int _bs_idx, int sector_idx, int tilt_z_idx, int tilt_a_idx, int ue_interference_index)
{
	int ms_idx = self_ms_idx;

	double h_angle_pi = channel[_bs_idx][self_ms_idx].LOS_AOA_GCS * (pi / 180.);  //// pi in GCS, rad
	double v_angle_theta = channel[_bs_idx][self_ms_idx].LOS_ZOA_GCS * (pi / 180.);  ///// theta in GCS, rad

	double F_theta_GCS_P1 = 0;
	double F_pi_GCS_P1 = 0;
	double F_theta_GCS_P2 = 0;
	double F_pi_GCS_P2 = 0;

	complex <double> F_rx_theta = (0, 0);
	complex <double> F_rx_pi = (0, 0);
	complex <double> F_rx_theta_2 = (0, 0);
	complex <double> F_rx_pi_2 = (0, 0);

	double combined_antenna_gain;


	if (ue_antenna_element_gain == 0) // UE omni-antenna case
	{

		
		combined_antenna_gain = 0;

		if (P == 0)
		{
			ReceiverAntennaGainXLOS_theta = 1.;
			ReceiverAntennaGainXLOS_pi = 0.;
		}
		else
		{
			ReceiverAntennaGainXLOS_theta = 0.;
			ReceiverAntennaGainXLOS_pi = 1.;
		}
		
		
	}
	else
	{

		combined_antenna_gain = Get_UE_antenna_pattern(P, v_angle_theta, h_angle_pi, ms_idx, sector_idx, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

		Get_UE_antenna_field_pattern(channel[_bs_idx][self_ms_idx].self_ms, M, N, P, ms_idx, sector_idx, tilt_z_idx, tilt_a_idx, v_angle_theta, h_angle_pi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_rx_theta, F_rx_pi, F_rx_theta_2, F_rx_pi_2);

		ReceiverAntennaGainXLOS_theta = F_rx_theta;
		ReceiverAntennaGainXLOS_pi = F_rx_pi;

		ReceiverAntennaGainXLOS_theta_panel_2 = F_rx_theta_2;
		ReceiverAntennaGainXLOS_pi_panel_2 = F_rx_pi_2;
	}


	return combined_antenna_gain;
}

double Get_BS_antenna_pattern(double theta_GCS, double pi_GCS, int bs_idx, int sector_index, double &F_theta_GCS_P1, double &F_pi_GCS_P1, double &F_theta_GCS_P2, double &F_pi_GCS_P2)
{
	if (TYPE == 11)   ///InH
	{
		double v_angle_theta_LCS_temp = 0.;
		double h_angle_pi_LCS_temp = 0.;

		/////  GCS -> LCS with mechanical down tile angle 
		/////  TR 36.814 / A.2.1.6.2 / equation (1),(2)
		/////GCS -> LCS , use alpha, beta, gamma
		///// TR 36.873

		double alpha = bs[bs_idx].ant[sector_index][0];
		double beta = bs[bs_idx].ant[sector_index][1];
		double gamma = bs[bs_idx].ant[sector_index][2];

		double zeta_1 = -pi / 4;
		double zeta_2 = pi / 4;

		double F_theta_LCS_P1;
		double F_pi_LCS_P1;
		double F_theta_LCS_P2;
		double F_pi_LCS_P2;

		double GCS_field_theta_P1;
		double GCS_field_pi_P1;
		double GCS_field_theta_P2;
		double GCS_field_pi_P2;

		v_angle_theta_LCS_temp = Get_LCS_theta(alpha, beta, gamma, theta_GCS, pi_GCS);
		h_angle_pi_LCS_temp = Get_LCS_pi(alpha, beta, gamma, theta_GCS, pi_GCS);

		v_angle_theta_LCS_temp = v_angle_theta_LCS_temp * (180. / pi);
		h_angle_pi_LCS_temp = h_angle_pi_LCS_temp * (180. / pi);

		double h_antgain = -MIN(12. * (h_angle_pi_LCS_temp / 90.)*(h_angle_pi_LCS_temp / 90.), 25.);
		double v_antgain = -MIN(12. * ((v_angle_theta_LCS_temp - 90.) / 90.) * ((v_angle_theta_LCS_temp - 90.) / 90.), 25.);

		double combined_antenna_gain = max_antgain - MIN(-(h_antgain + v_antgain), 25.);

		/// Polarized antennas Model-2
		/// 36.873 -> 7.1.1
		double A = sqrt(pow(10.0, (combined_antenna_gain / 10.0)));

		F_theta_LCS_P1 = A * cos(zeta_1);
		F_pi_LCS_P1    = A * sin(zeta_1);
		F_theta_LCS_P2 = A * cos(zeta_2);
		F_pi_LCS_P2    = A * sin(zeta_2);
		//// 

		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P1, F_pi_LCS_P1, GCS_field_theta_P1, GCS_field_pi_P1);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P2, F_pi_LCS_P2, GCS_field_theta_P2, GCS_field_pi_P2);

		F_theta_GCS_P1 = GCS_field_theta_P1;
		F_pi_GCS_P1    = GCS_field_pi_P1;
		F_theta_GCS_P2 = GCS_field_theta_P2;
		F_pi_GCS_P2    = GCS_field_pi_P2;

		return combined_antenna_gain;
	}
	else if (TYPE == 12) /// Dense Urban
	{
		int _sector_idx = sector_index;

		double v_angle_theta_LCS_temp = 0.;
		double h_angle_pi_LCS_temp = 0.;

		double alpha = bs[bs_idx].ant[_sector_idx][0];
		double beta = bs[bs_idx].ant[_sector_idx][1];
		double gamma = bs[bs_idx].ant[_sector_idx][2];

		double zeta_1 = -pi / 4;
		double zeta_2 = pi / 4;

		double F_theta_LCS_P1;
		double F_pi_LCS_P1;
		double F_theta_LCS_P2;
		double F_pi_LCS_P2;

		double GCS_field_theta_P1;
		double GCS_field_pi_P1;
		double GCS_field_theta_P2;
		double GCS_field_pi_P2;

		v_angle_theta_LCS_temp = Get_LCS_theta(alpha, beta, gamma, theta_GCS, pi_GCS);    /// radian
		h_angle_pi_LCS_temp = Get_LCS_pi(alpha, beta, gamma, theta_GCS, pi_GCS);

		v_angle_theta_LCS_temp = v_angle_theta_LCS_temp * (180. / pi);                    /// degree
		h_angle_pi_LCS_temp = h_angle_pi_LCS_temp * (180. / pi);

		double h_antgain = -MIN(12. * (h_angle_pi_LCS_temp / 65.)*(h_angle_pi_LCS_temp / 65.), 30.);
		double v_antgain = -MIN(12. * ((v_angle_theta_LCS_temp - 90.) / 65.) * ((v_angle_theta_LCS_temp - 90.) / 65.), 30.);

		double combined_antenna_gain = max_antgain - MIN(-(h_antgain + v_antgain), 30.);

		/// Polarized antennas Model-2
		/// 36.873 -> 7.1.1
		double A = sqrt(pow(10.0, (combined_antenna_gain / 10.0)));

		F_theta_LCS_P1 = A * cos(zeta_1);
		F_pi_LCS_P1    = A * sin(zeta_1);
		F_theta_LCS_P2 = A * cos(zeta_2);
		F_pi_LCS_P2    = A * sin(zeta_2);
		//// 

		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P1, F_pi_LCS_P1, GCS_field_theta_P1, GCS_field_pi_P1);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P2, F_pi_LCS_P2, GCS_field_theta_P2, GCS_field_pi_P2);

		F_theta_GCS_P1 = GCS_field_theta_P1;
		F_pi_GCS_P1    = GCS_field_pi_P1;
		F_theta_GCS_P2 = GCS_field_theta_P2;
		F_pi_GCS_P2    = GCS_field_pi_P2;

		return combined_antenna_gain;

	}
	else if (TYPE == 13) /// Rural
	{
		int _sector_idx = sector_index;

		double v_angle_theta_LCS_temp = 0.;
		double h_angle_pi_LCS_temp = 0.;

		double alpha = bs[bs_idx].ant[_sector_idx][0];
		double beta = bs[bs_idx].ant[_sector_idx][1];
		double gamma = bs[bs_idx].ant[_sector_idx][2];

		double zeta_1 = -pi / 4;
		double zeta_2 = pi / 4;

		double F_theta_LCS_P1;
		double F_pi_LCS_P1;
		double F_theta_LCS_P2;
		double F_pi_LCS_P2;

		double GCS_field_theta_P1;
		double GCS_field_pi_P1;
		double GCS_field_theta_P2;
		double GCS_field_pi_P2;

		v_angle_theta_LCS_temp = Get_LCS_theta(alpha, beta, gamma, theta_GCS, pi_GCS);    /// radian
		h_angle_pi_LCS_temp = Get_LCS_pi(alpha, beta, gamma, theta_GCS, pi_GCS);

		v_angle_theta_LCS_temp = v_angle_theta_LCS_temp * (180. / pi);                    /// degree
		h_angle_pi_LCS_temp = h_angle_pi_LCS_temp * (180. / pi);

		double h_antgain = -MIN(12. * (h_angle_pi_LCS_temp / 65.)*(h_angle_pi_LCS_temp / 65.), 30.);
		double v_antgain = -MIN(12. * ((v_angle_theta_LCS_temp - 90.) / 65.) * ((v_angle_theta_LCS_temp - 90.) / 65.), 30.);

		double combined_antenna_gain = max_antgain - MIN(-(h_antgain + v_antgain), 30.);


		/// Polarized antennas Model-2
		/// 36.873 -> 7.1.1
		double A = sqrt(pow(10.0, (combined_antenna_gain / 10.0)));

		F_theta_LCS_P1 = A * cos(zeta_1);
		F_pi_LCS_P1    = A * sin(zeta_1);
		F_theta_LCS_P2 = A * cos(zeta_2);
		F_pi_LCS_P2    = A * sin(zeta_2);
		//// 

		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P1, F_pi_LCS_P1, GCS_field_theta_P1, GCS_field_pi_P1);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P2, F_pi_LCS_P2, GCS_field_theta_P2, GCS_field_pi_P2);

		F_theta_GCS_P1 = GCS_field_theta_P1;
		F_pi_GCS_P1    = GCS_field_pi_P1;
		F_theta_GCS_P2 = GCS_field_theta_P2;
		F_pi_GCS_P2    = GCS_field_pi_P2;

		return combined_antenna_gain;
	}
}





complex <double> Get_BS_antenna_field_pattern(LOCATION interferer, int _bs_idx, int _sec_idx, int tilt_z_idx, int tilt_a_idx, double v_angle_theta, double h_angle_pi, double F_theta_GCS_P1, double F_pi_GCS_P1, double F_theta_GCS_P2, double F_pi_GCS_P2, complex <double> &F_tx_theta, complex <double> &F_tx_pi)
{
	double dH;
	double dV;

	dH = BS_dH;
	dV = BS_dV;

	int K = BS_M / BS_Mp;    /////   4 / 4 = 1
	int L = BS_N / BS_Np;   //////   4/4 = 1

	complex <double>jay(0.0, 1.0);
	complex <double> F_theta_temp = (0,0);
	complex <double> F_pi_temp = (0, 0);
	complex <double> weight = 0;
	complex <double> w;
	LOCATION3D d_tx;
	LOCATION3D r_tx;

	double Theta = v_angle_theta;
	double Phi = h_angle_pi;

	r_tx.x = sin(Theta) * cos(Phi);
	r_tx.y = sin(Theta) * sin(Phi);
	r_tx.z = cos(Theta);

	weight = (0, 0);

	for (int k = 0; k < K; k++) // vertical element
	{
		for (int l = 0; l < L; l++) // horizental element
		{
			w = virtualization_weight_wv[tilt_z_idx][tilt_a_idx][k][l];
			d_tx.x = bs[_bs_idx].d_tx[_sec_idx][k][l][0][0][0].x;// +interferer.x; //// sector(rx) [M][N][P][Mg][Ng] <port0>   channel[bs_idx][ms_idx].self_bs.x
			d_tx.y = bs[_bs_idx].d_tx[_sec_idx][k][l][0][0][0].y;// +interferer.y; //// sector(rx) [M][N][P][Mg][Ng] <port0>   channel[bs_idx][ms_idx].self_bs.y
			d_tx.z = bs[_bs_idx].d_tx[_sec_idx][k][l][0][0][0].z;// +bs_height;    //// sector(rx) [M][N][P][Mg][Ng] <port0>   bs_height
			weight += w * exp(jay*2.0*pi / Wavelength * dot(r_tx, d_tx));
		}
	}

	F_theta_temp = (F_theta_GCS_P1  * weight);
	F_pi_temp    = (F_pi_GCS_P1     * weight);


	/// F, antenna gain for RSRP
	F_tx_theta = F_theta_temp;
	F_tx_pi    = F_pi_temp;

	return 0;
}



double Get_UE_antenna_pattern(int P, double theta_GCS, double pi_GCS, int ms_idx, int sector_index, double &F_theta_GCS_P1, double &F_pi_GCS_P1, double &F_theta_GCS_P2, double &F_pi_GCS_P2)
{
	if (TYPE == 11 || TYPE == 12)   ///InH
	{
		double v_angle_theta_LCS_temp = 0.;
		double h_angle_pi_LCS_temp = 0.;
		double v_angle_theta_LCS_temp_Panel2 = 0.;
		double h_angle_pi_LCS_temp_Panel2 = 0.;

		/////  GCS -> LCS with mechanical down tile angle 
		/////  TR 36.814 / A.2.1.6.2 / equation (1),(2)
		double alpha = ms[ms_idx].alpha;
		double beta = ms[ms_idx].beta;
		double gamma = ms[ms_idx].gamma;
		double alpha_plus_pi = ms[ms_idx].alpha + pi;

		double zeta_1 = 0;
		double zeta_2 = pi / 2;

		double F_theta_LCS_P1;
		double F_pi_LCS_P1;
		double F_theta_LCS_P2;
		double F_pi_LCS_P2;

		double F_theta_LCS_P1_Panel2;
		double F_pi_LCS_P1_Panel2;
		double F_theta_LCS_P2_Panel2;
		double F_pi_LCS_P2_Panel2;

		double GCS_field_theta_P1;
		double GCS_field_pi_P1;
		double GCS_field_theta_P2;
		double GCS_field_pi_P2;

		double GCS_field_theta_P1_Panel2;
		double GCS_field_pi_P1_Panel2;
		double GCS_field_theta_P2_Panel2;
		double GCS_field_pi_P2_Panel2;

		v_angle_theta_LCS_temp = Get_LCS_theta(alpha, beta, gamma, theta_GCS, pi_GCS);
		h_angle_pi_LCS_temp    = Get_LCS_pi(alpha, beta, gamma, theta_GCS, pi_GCS);
		v_angle_theta_LCS_temp_Panel2 = Get_LCS_theta(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS);
		h_angle_pi_LCS_temp_Panel2    = Get_LCS_pi(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS);

		v_angle_theta_LCS_temp = v_angle_theta_LCS_temp * (180. / pi);   // degree
		h_angle_pi_LCS_temp    = h_angle_pi_LCS_temp    * (180. / pi);
		v_angle_theta_LCS_temp_Panel2 = v_angle_theta_LCS_temp_Panel2 * (180. / pi);   // degree
		h_angle_pi_LCS_temp_Panel2    = h_angle_pi_LCS_temp_Panel2    * (180. / pi);

		double h_antgain        = -MIN(12. * (h_angle_pi_LCS_temp / 90.)*(h_angle_pi_LCS_temp / 90.), 25.);
		double v_antgain        = -MIN(12. * ((v_angle_theta_LCS_temp - 90.) / 90.) * ((v_angle_theta_LCS_temp - 90.) / 90.), 25.);
		double h_antgain_Panel2 = -MIN(12. * (h_angle_pi_LCS_temp_Panel2 / 90.)*(h_angle_pi_LCS_temp_Panel2 / 90.), 25.);
		double v_antgain_Panel2 = -MIN(12. * ((v_angle_theta_LCS_temp_Panel2 - 90.) / 90.) * ((v_angle_theta_LCS_temp_Panel2 - 90.) / 90.), 25.);

		double combined_antenna_gain        = ue_antenna_element_gain - MIN(-(h_antgain + v_antgain), 25.);
		double combined_antenna_gain_Panel2 = ue_antenna_element_gain - MIN(-(h_antgain_Panel2 + v_antgain_Panel2), 25.);

		if (Frequency < 6000000000)  //below 6Ghz
		{
			combined_antenna_gain = 0.;
			combined_antenna_gain_Panel2 = 0.;
		}

		double A  = sqrt(pow(10.0, (combined_antenna_gain / 10.0)));
		double A2 = sqrt(pow(10.0, (combined_antenna_gain_Panel2 / 10.0)));

		F_theta_LCS_P1 = A * cos(zeta_1);
		F_pi_LCS_P1    = A * sin(zeta_1);
		F_theta_LCS_P2 = A * cos(zeta_2);
		F_pi_LCS_P2    = A * sin(zeta_2);

		F_theta_LCS_P1_Panel2 = A2 * cos(zeta_1);
		F_pi_LCS_P1_Panel2    = A2 * sin(zeta_1);
		F_theta_LCS_P2_Panel2 = A2 * cos(zeta_2);
		F_pi_LCS_P2_Panel2    = A2 * sin(zeta_2);
		////


		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P1, F_pi_LCS_P1, GCS_field_theta_P1, GCS_field_pi_P1);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P2, F_pi_LCS_P2, GCS_field_theta_P2, GCS_field_pi_P2);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P1_Panel2, F_pi_LCS_P1_Panel2, GCS_field_theta_P1_Panel2, GCS_field_pi_P1_Panel2);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P2_Panel2, F_pi_LCS_P2_Panel2, GCS_field_theta_P2_Panel2, GCS_field_pi_P2_Panel2);
		
		if (ue_antenna_element_gain == 0)
		{
			F_theta_GCS_P1 = GCS_field_theta_P1;
			F_pi_GCS_P1    = GCS_field_pi_P1;
			F_theta_GCS_P2 = GCS_field_theta_P2;  
			F_pi_GCS_P2    = GCS_field_pi_P2;
		}
		else
		{
			if (P == 0)
			{
				F_theta_GCS_P1 = GCS_field_theta_P1;
				F_pi_GCS_P1    = GCS_field_pi_P1;
				F_theta_GCS_P2 = GCS_field_theta_P1_Panel2;  //// P2 Panel2 ޾ƿ ߵ.  Polarization. ϳ Polarization   ϱ⋚...
				F_pi_GCS_P2    = GCS_field_pi_P1_Panel2;
			}
			else
			{
				F_theta_GCS_P1 = GCS_field_theta_P2;
				F_pi_GCS_P1    = GCS_field_pi_P2;
				F_theta_GCS_P2 = GCS_field_theta_P2_Panel2;  //// P2 Panel2 ޾ƿ ߵ.  Polarization. ϳ Polarization   ϱ⋚...
				F_pi_GCS_P2    = GCS_field_pi_P2_Panel2;
			}

		}


		/*
		F_theta_GCS_P1_Panel2 = GCS_field_theta_P1_Panel2;
		F_pi_GCS_P1_Panel2 = GCS_field_pi_P1_Panel2;
		F_theta_GCS_P2_Panel2 = GCS_field_theta_P2_Panel2;
		F_pi_GCS_P2_Panel2 = GCS_field_pi_P2_Panel2;
		//// -> F_tx_
		*/

		return combined_antenna_gain;


	}
	else if (TYPE == 13) /// Rural
	{
		double v_angle_theta_LCS_temp = 0.;
		double h_angle_pi_LCS_temp = 0.;
		double v_angle_theta_LCS_temp_Panel2 = 0.;
		double h_angle_pi_LCS_temp_Panel2 = 0.;

		/////  GCS -> LCS with mechanical down tile angle 
		/////  TR 36.814 / A.2.1.6.2 / equation (1),(2)
		double alpha = ms[ms_idx].alpha;
		double beta = ms[ms_idx].beta;
		double gamma = ms[ms_idx].gamma;
		double alpha_plus_pi = ms[ms_idx].alpha + pi;

		double zeta_1 = 0;
		double zeta_2 = pi / 2;

		double F_theta_LCS_P1;
		double F_pi_LCS_P1;
		double F_theta_LCS_P2;
		double F_pi_LCS_P2;

		double F_theta_LCS_P1_Panel2;
		double F_pi_LCS_P1_Panel2;
		double F_theta_LCS_P2_Panel2;
		double F_pi_LCS_P2_Panel2;

		double GCS_field_theta_P1;
		double GCS_field_pi_P1;
		double GCS_field_theta_P2;
		double GCS_field_pi_P2;

		double GCS_field_theta_P1_Panel2;
		double GCS_field_pi_P1_Panel2;
		double GCS_field_theta_P2_Panel2;
		double GCS_field_pi_P2_Panel2;

		v_angle_theta_LCS_temp = Get_LCS_theta(alpha, beta, gamma, theta_GCS, pi_GCS);
		h_angle_pi_LCS_temp = Get_LCS_pi(alpha, beta, gamma, theta_GCS, pi_GCS);
		v_angle_theta_LCS_temp_Panel2 = Get_LCS_theta(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS);
		h_angle_pi_LCS_temp_Panel2 = Get_LCS_pi(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS);

		v_angle_theta_LCS_temp = v_angle_theta_LCS_temp * (180. / pi);   // degree
		h_angle_pi_LCS_temp = h_angle_pi_LCS_temp    * (180. / pi);
		v_angle_theta_LCS_temp_Panel2 = v_angle_theta_LCS_temp_Panel2 * (180. / pi);   // degree
		h_angle_pi_LCS_temp_Panel2 = h_angle_pi_LCS_temp_Panel2    * (180. / pi);

		double h_antgain = -MIN(12. * (h_angle_pi_LCS_temp / 90.)*(h_angle_pi_LCS_temp / 90.), 25.);
		double v_antgain = -MIN(12. * ((v_angle_theta_LCS_temp - 90.) / 90.) * ((v_angle_theta_LCS_temp - 90.) / 90.), 25.);
		double h_antgain_Panel2 = -MIN(12. * (h_angle_pi_LCS_temp_Panel2 / 90.)*(h_angle_pi_LCS_temp_Panel2 / 90.), 25.);
		double v_antgain_Panel2 = -MIN(12. * ((v_angle_theta_LCS_temp_Panel2 - 90.) / 90.) * ((v_angle_theta_LCS_temp_Panel2 - 90.) / 90.), 25.);

		double combined_antenna_gain = ue_antenna_element_gain - MIN(-(h_antgain + v_antgain), 25.);
		double combined_antenna_gain_Panel2 = ue_antenna_element_gain - MIN(-(h_antgain_Panel2 + v_antgain_Panel2), 25.);

		if (Frequency < 6000000000)  //below 6Ghz
		{
			combined_antenna_gain = 0.;
			combined_antenna_gain_Panel2 = 0.;
		}

		double A = sqrt(pow(10.0, (combined_antenna_gain / 10.0)));
		double A2 = sqrt(pow(10.0, (combined_antenna_gain_Panel2 / 10.0)));

		F_theta_LCS_P1 = A * cos(zeta_1);
		F_pi_LCS_P1 = A * sin(zeta_1);
		F_theta_LCS_P2 = A * cos(zeta_2);
		F_pi_LCS_P2 = A * sin(zeta_2);

		F_theta_LCS_P1_Panel2 = A2 * cos(zeta_1);
		F_pi_LCS_P1_Panel2 = A2 * sin(zeta_1);
		F_theta_LCS_P2_Panel2 = A2 * cos(zeta_2);
		F_pi_LCS_P2_Panel2 = A2 * sin(zeta_2);
		//// 


		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P1, F_pi_LCS_P1, GCS_field_theta_P1, GCS_field_pi_P1);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P2, F_pi_LCS_P2, GCS_field_theta_P2, GCS_field_pi_P2);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P1_Panel2, F_pi_LCS_P1_Panel2, GCS_field_theta_P1_Panel2, GCS_field_pi_P1_Panel2);
		LCS_Antenna_field_to_GCS_antenna_pattern(alpha_plus_pi, beta, gamma, theta_GCS, pi_GCS, F_theta_LCS_P2_Panel2, F_pi_LCS_P2_Panel2, GCS_field_theta_P2_Panel2, GCS_field_pi_P2_Panel2);

		if (ue_antenna_element_gain == 0)
		{
			F_theta_GCS_P1 = GCS_field_theta_P1;
			F_pi_GCS_P1 = GCS_field_pi_P1;
			F_theta_GCS_P2 = GCS_field_theta_P2;
			F_pi_GCS_P2 = GCS_field_pi_P2;
		}
		else
		{
			if (P == 0)
			{
				F_theta_GCS_P1 = GCS_field_theta_P1;
				F_pi_GCS_P1 = GCS_field_pi_P1;
				F_theta_GCS_P2 = GCS_field_theta_P1_Panel2;  //// P2 Panel2
				F_pi_GCS_P2 = GCS_field_pi_P1_Panel2;
			}
			else
			{
				F_theta_GCS_P1 = GCS_field_theta_P2;
				F_pi_GCS_P1 = GCS_field_pi_P2;
				F_theta_GCS_P2 = GCS_field_theta_P2_Panel2;  //// P2 Panel2
				F_pi_GCS_P2 = GCS_field_pi_P2_Panel2;
			}

		}


		/*
		F_theta_GCS_P1_Panel2 = GCS_field_theta_P1_Panel2;
		F_pi_GCS_P1_Panel2 = GCS_field_pi_P1_Panel2;
		F_theta_GCS_P2_Panel2 = GCS_field_theta_P2_Panel2;
		F_pi_GCS_P2_Panel2 = GCS_field_pi_P2_Panel2;
		//// -> F_tx_
		*/

		return combined_antenna_gain;
	}

	
}





complex <double> Get_UE_antenna_field_pattern(LOCATION UE, int M, int N, int P, int ms_idx, int sector_idx, int tilt_z_idx, int tilt_a_idx, double v_angle_theta, double h_angle_pi, double F_theta_GCS_P1, double F_pi_GCS_P1, double F_theta_GCS_P2, double F_pi_GCS_P2, complex <double> &F_rx_theta_panel_1, complex <double> &F_rx_pi_panel_1, complex <double> &F_rx_theta_panel_2, complex <double> &F_rx_pi_panel_2)
{

	double dH;
	double dV;

	dH = MS_dH;
	dV = MS_dV;

	int K = MS_M / MS_Mp;    /////   4 / 4 = 1
	int L = MS_N / MS_Np;   //////   4/4 = 1

	if (ue_antenna_element_gain == 0)
	{
		K = MS_M;
		L = MS_N;
	}

	complex <double>jay(0, 1);

	complex <double> F_theta_temp = (0, 0);
	complex <double> F_pi_temp = (0, 0);
	complex <double> F_theta_temp_2 = (0, 0);
	complex <double> F_pi_temp_2 = (0, 0);


	complex <double> weight[2];
	weight[0] = (0, 0);
	weight[1] = (0, 0);

	complex <double> w;
	LOCATION3D d_rx[2];
	LOCATION3D r_rx;

	double Theta = v_angle_theta;
	double Phi = h_angle_pi;

	r_rx.x = sin(Theta) * cos(Phi);
	r_rx.y = sin(Theta) * sin(Phi);
	r_rx.z = cos(Theta);

	if (ue_antenna_element_gain == 0)
	{

		w = 1.;
		d_rx[0].x = ms[ms_idx].d_rx[M][N][0][0][0].x;// +UE.x; //// [M][N][P][Mg][Ng] <panel0>	
		d_rx[0].y = ms[ms_idx].d_rx[M][N][0][0][0].y;// +UE.y; //// [M][N][P][Mg][Ng] <panel0>	
		d_rx[0].z = ms[ms_idx].d_rx[M][N][0][0][0].z;// +ms[ms_idx].MS_HEIGHT_FINAL - bs_height; //// [M][N][P][Mg][Ng] <panel0>	




		weight[0] = exp(jay*2.0*pi / Wavelength * dot(r_rx, d_rx[0]));


		F_theta_temp = (F_theta_GCS_P1  * weight[0]);
		F_pi_temp    = (F_pi_GCS_P1     * weight[0]);
		F_theta_temp_2 = (F_theta_GCS_P2  * weight[0]);   // P2 ⼭ Polarization
		F_pi_temp_2    = (F_pi_GCS_P2     * weight[0]);


		/// F, antenna gain for RSRP
		F_rx_theta_panel_1 = F_theta_temp;
		F_rx_pi_panel_1 = F_pi_temp;

		F_rx_theta_panel_2 = F_theta_temp_2;
		F_rx_pi_panel_2 = F_pi_temp_2;
	}
	else
	{
		for (int k = 0; k < K; k++) // vertical element
		{
			for (int l = 0; l < L; l++) // horizental element
			{
				w = ue_virtualization_weight_wv[tilt_z_idx][tilt_a_idx][k][l];
				d_rx[0].x = ms[ms_idx].d_rx[k][l][0][0][0].x; // +UE.x; //// [M][N][P][Mg][Ng] <panel0>
				d_rx[0].y = ms[ms_idx].d_rx[k][l][0][0][0].y; // +UE.y; //// [M][N][P][Mg][Ng] <panel0>
				d_rx[0].z = ms[ms_idx].d_rx[k][l][0][0][0].z; // +ms[ms_idx].MS_HEIGHT_FINAL - bs_height; //// [M][N][P][Mg][Ng] <panel0>

				d_rx[1].x = ms[ms_idx].d_rx[k][l][0][0][1].x; // +UE.x; //// [M][N][P][Mg][Ng] <panel1>
				d_rx[1].y = ms[ms_idx].d_rx[k][l][0][0][1].y; // +UE.y; //// [M][N][P][Mg][Ng] <panel1>
				d_rx[1].z = ms[ms_idx].d_rx[k][l][0][0][1].z; // +ms[ms_idx].MS_HEIGHT_FINAL - bs_height; //// [M][N][P][Mg][Ng] <panel1>


				weight[0] += w * exp(jay*2.0*pi / Wavelength * dot(r_rx, d_rx[0]));
				weight[1] += w * exp(jay*2.0*pi / Wavelength * dot(r_rx, d_rx[1]));
			}
		}
		F_theta_temp = (F_theta_GCS_P1  * weight[0]);
		F_pi_temp    = (F_pi_GCS_P1     * weight[0]);

		F_theta_temp_2 = (F_theta_GCS_P2  * weight[1]);   // P2 Panel2
		F_pi_temp_2    = (F_pi_GCS_P2     * weight[1]);


		/// F, antenna gain for RSRP
		F_rx_theta_panel_1 = F_theta_temp;
		F_rx_pi_panel_1 = F_pi_temp;

		F_rx_theta_panel_2 = F_theta_temp_2;
		F_rx_pi_panel_2 = F_pi_temp_2;
	}


	return 0;
		
}



void LCS_Antenna_field_to_GCS_antenna_pattern(double alpha, double beta, double gamma, double GCS_angle_theta, double GCS_angle_pi, double LCS_field_theta, double LCS_field_pi, double &GCS_field_theta, double &GCS_field_pi) //GCS_angle degree
{

	double cos_psi;
	double sin_psi;
	double theta = GCS_angle_theta; // rad
	double phi = GCS_angle_pi; // rad

	if ((pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2) == 1) || (pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2) == 1))
	{
		theta += 0.0001;
	}

	cos_psi = (cos(beta)*cos(gamma)*sin(theta) - (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*cos(theta)) / sqrt(1.0 - pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2));
	sin_psi = (sin(beta)*cos(gamma)*sin(phi - alpha) + sin(gamma)*cos(phi - alpha)) / sqrt(1.0 - pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2));;

	GCS_field_theta = cos_psi * LCS_field_theta - sin_psi * LCS_field_pi;
	GCS_field_pi = sin_psi * LCS_field_theta + cos_psi * LCS_field_pi;


}


void PIot_sector_antenna_gain()
{

	complex <double> w;
	LOCATION3D r_rx;
	LOCATION3D d_rx[3];
	complex <double> weight[3];
	complex <double> j(0.0, 1.0);
	SPHERICAL_ANGLE A;
	SPHERICAL_ANGLE A_LCS[3];
	double antenna_gain[3];
	ANTENNA_FIELD F[3];
	ANTENNA_FIELD F_LCS[3];

	ofstream x;
	ofstream y;

	int K = BS_M / BS_Mp;    /////   4 / 4 = 1
	int L = BS_N / BS_Np;   //////   4/4 = 1

	MatrixXcd wei(K, L);
	double dH;
	double dV;

	dH = BS_dH;
	dV = BS_dV;

	x.open("output/x.dat");
	y.open("output/y.dat");
	for (int theta = 0; theta < 181; theta++)
	{
		for (int phi = -180; phi < 181; phi++)
		{

			r_rx = Transform_angle_to_spheical_vector(double(phi), double(theta));
			x << r_rx.x << '\t';
			y << r_rx.y << '\t';
		}
		x << endl;
		y << endl;
	}
	x.close();
	y.close();

	ofstream out[3];
	string filename[3];



	for (int z = 0; z < tilt_zenith_angle_LCS_size; z++)
	{
		cout << z << endl;
		for (int a = 0; a < tilt_azimuth_angle_LCS_size; a++)
		{
			stringstream fn[3];
			fn[0] << "output/sector_gain/" << "sector_0_zenith_" << z << "_azimuth_" << a << ".dat";
			fn[1] << "output/sector_gain/" << "sector_1_zenith_" << z << "_azimuth_" << a << ".dat";
			fn[2] << "output/sector_gain/" << "sector_2_zenith_" << z << "_azimuth_" << a << ".dat";

			filename[0] = fn[0].str();
			filename[1] = fn[1].str();
			filename[2] = fn[2].str();
			fn[0].clear();
			fn[1].clear();
			fn[2].clear();

			out[0].open(filename[0]);
			out[1].open(filename[1]);
			out[2].open(filename[2]);

			for (int theta = 0; theta<181; theta++)
			{
				for (int phi = -180; phi<181; phi++)
				{
					A.phi = double(phi) * (pi / 180.);;
					A.theta = double(theta) * (pi / 180.);;

					for (int sector_idx = 0; sector_idx < 3; sector_idx++)
					{
						double	F_theta_GCS_P1;
						double F_pi_GCS_P1; 
						double F_theta_GCS_P2;
						double F_pi_GCS_P2;

						complex <double> F_tx_theta;
						complex <double> F_tx_pi;

						LOCATION AA;
						AA.x = 0;
						AA.y = 0;

						double combined_antenna_gain = Get_BS_antenna_pattern(A.theta, A.phi, 0, sector_idx, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

						F[sector_idx].theta = F_theta_GCS_P1;
						F[sector_idx].phi = F_pi_GCS_P1;



						Get_BS_antenna_field_pattern(AA, 0, sector_idx, z, a, A.theta, A.phi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_tx_theta, F_tx_pi);

						out[sector_idx] << pow(abs(F_tx_theta), 2) + pow(abs(F_tx_pi), 2) << '\t';

					}
				}
				out[0] << endl;
				out[1] << endl;
				out[2] << endl;
			}
			out[0].close();
			out[1].close();
			out[2].close();
		}
	}
	cout << "sector gain--" << endl;
}


void PIot_ue_antenna_gain()
{

	complex <double> w;
	LOCATION3D r_rx;
	LOCATION3D d_rx[3];
	complex <double> weight[3];
	complex <double> j(0.0, 1.0);
	SPHERICAL_ANGLE A;
	SPHERICAL_ANGLE A_LCS[3];
	double antenna_gain[3];
	ANTENNA_FIELD F[3];
	ANTENNA_FIELD F_LCS[3];

	ofstream out0;
	ofstream out1;

	ofstream x;
	ofstream y;



	int K = MS_M / MS_Mp;    /////   4 / 4 = 1
	int L = MS_N / MS_Np;   //////   4/4 = 1

	MatrixXcd wei(K, L);
	double dH;
	double dV;

	dH = MS_dH;
	dV = MS_dV;

	x.open("output/x.dat");
	y.open("output/y.dat");
	for (int theta = 0; theta < 181; theta++)
	{
		for (int phi = -180; phi < 181; phi++)
		{

			r_rx = Transform_angle_to_spheical_vector(double(phi), double(theta));
			x << r_rx.x << '\t';
			y << r_rx.y << '\t';
		}
		x << endl;
		y << endl;
	}
	x.close();
	y.close();


	string filename[2];



	for (int z = 0; z < ue_tilt_zenith_angle_LCS_size; z++)
	{
		cout << z << endl;
		for (int a = 0; a < ue_tilt_azimuth_angle_LCS_size; a++)
		{
			stringstream fn;
			stringstream fn1;

			fn << "output/" << "ue_pannel_0_zenith_" << z << "_azimuth_" << a << ".dat";
			fn1 << "output/" << "ue_pannel_1_zenith_" << z << "_azimuth_" << a << ".dat";
			filename[0] = fn.str();
			filename[1] = fn1.str();

			fn.clear();
			fn1.clear();

			out0.open(filename[0]);
			out1.open(filename[1]);

			for (int theta = 0; theta<181; theta++)
			{
				for (int phi = -180; phi<181; phi++)
				{
					A.phi = double(phi) * (pi / 180.);;
					A.theta = double(theta) * (pi / 180.);;


						double	F_theta_GCS_P1;
						double F_pi_GCS_P1;
						double F_theta_GCS_P2;
						double F_pi_GCS_P2;

						complex <double> F_tx_theta;
						complex <double> F_tx_pi;
						complex <double> F_tx_theta_Panel2;
						complex <double> F_tx_pi_Panel2;

						double combined_antenna_gain = Get_UE_antenna_pattern(0, A.theta, A.phi, 0, 0, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2);

						F[0].theta = F_theta_GCS_P1;
						F[0].phi = F_pi_GCS_P1;

						LOCATION AA;
						AA.x = 0;
						AA.y = 0;

						Get_UE_antenna_field_pattern(AA, 0, 0, 0, 0, 0, z, a, A.theta, A.phi, F_theta_GCS_P1, F_pi_GCS_P1, F_theta_GCS_P2, F_pi_GCS_P2, F_tx_theta, F_tx_pi, F_tx_theta_Panel2, F_tx_pi_Panel2);

						out0 << pow(abs(F_tx_theta), 2) + pow(abs(F_tx_pi), 2) << '\t';
						out1 << pow(abs(F_tx_theta_Panel2), 2) + pow(abs(F_tx_pi_Panel2), 2) << '\t';


				}
				out0 << endl;
				out1 << endl;

			}
			out0.close();
			out1.close();
		}
	}

	cout << "ue gain--" << endl;
}

void LINK::Delete_link_memory()
{
	delete[] LS_gain;
	delete[] static_gain;

	SmallScale_TX_AntennaGainXLOS_theta.resize(0,0);
	SmallScale_TX_AntennaGainXLOS_pi.resize(0, 0);
	SmallScale_RX_AntennaGainXLOS_theta.resize(0, 0);
	SmallScale_RX_AntennaGainXLOS_pi.resize(0, 0);
	SmallScale_RX_AntennaGainXLOS_theta_panel_2.resize(0, 0);
	SmallScale_RX_AntennaGainXLOS_pi_panel_2.resize(0, 0);
}




ANTENNA_FIELD Antenna_field_in_LCS(double LCS_antenna_gain_in_dB, double zeta)
{
	ANTENNA_FIELD field_pattern;
	double LCS_antenna_gain = dB2linear(LCS_antenna_gain_in_dB);

	field_pattern.theta = pow(LCS_antenna_gain, 0.5)*cos(zeta);
	field_pattern.phi = pow(LCS_antenna_gain, 0.5)*sin(zeta);

	return field_pattern;
}

double dot(LOCATION3D a, LOCATION3D b)
{
	return a.x*b.x + a.y*b.y + a.z*b.z;
}



LOCATION3D Transform_angle_to_spheical_vector(double phi, double theta)
{
	LOCATION3D r;

	double Theta = theta / 180 * pi;
	double Phi = phi / 180 * pi;

	r.x = sin(Theta) * cos(Phi);
	r.y = sin(Theta) * sin(Phi);
	r.z = cos(Theta);

	return r;
}

SPHERICAL_ANGLE GCS_Angle_to_LCS_Angle(double alpha, double beta, double gamma, SPHERICAL_ANGLE GCS_angle) //GCS_angle : degree  ||  alpha, beta gamma : radian
{
	SPHERICAL_ANGLE LCS_angle;
	double theta = GCS_angle.theta * pi / 180;
	double phi = GCS_angle.phi * pi / 180;

	LCS_angle.theta = acosl(cos(beta) * cos(gamma) * cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta));

	LCS_angle.phi = atan2l((cos(beta)*sin(gamma)*cos(theta) + (sin(beta)*sin(gamma)*cos(phi - alpha) + cos(gamma)*sin(phi - alpha))*sin(theta)), (cos(beta)*sin(theta)*cos(phi - alpha) - sin(beta)*cos(theta)));

	LCS_angle.theta = LCS_angle.theta * 180 / pi;

	LCS_angle.phi = LCS_angle.phi * 180 / pi;
	return LCS_angle;
}


double Sector_Antenna_gain_in_dB(SPHERICAL_ANGLE LCS_angle) //LCS_angle : degree
{
	double _3dB_angle;
	double SLA;
	double Am;
	double antenna_gain_Vertical;
	double antenna_gain_Horizontal;
	double antenna_gain;


	_3dB_angle = 65;
	SLA = 30;
	Am = 30;;



	antenna_gain_Vertical = -min(12 * pow(((LCS_angle.theta - 90.0) / _3dB_angle), 2), SLA);
	antenna_gain_Horizontal = -min(12 * pow((LCS_angle.phi / _3dB_angle), 2), Am);
	antenna_gain = -(min(-(antenna_gain_Vertical + antenna_gain_Horizontal), Am));

	antenna_gain = antenna_gain + max_antgain;

	return antenna_gain;

}

double UE_Antenna_gain_in_dB(SPHERICAL_ANGLE LCS_angle) //LCS_angle : degree
{
	double _3dB_angle;
	double SLA;
	double Am;
	double antenna_gain_Vertical;
	double antenna_gain_Horizontal;
	double antenna_gain;

	_3dB_angle = 90;
	SLA = 25;
	Am = 25;;

	antenna_gain_Vertical = -min(12 * pow(((LCS_angle.theta - 90.0) / _3dB_angle), 2), SLA);
	antenna_gain_Horizontal = -min(12 * pow((LCS_angle.phi / _3dB_angle), 2), Am);
	antenna_gain = -(min(-(antenna_gain_Vertical + antenna_gain_Horizontal), Am));

	antenna_gain = antenna_gain + ue_antenna_element_gain;

	return antenna_gain;

}

ANTENNA_FIELD LCS_Antenna_field_to_GCS_antenna_pattern_rev(double alpha, double beta, double gamma, SPHERICAL_ANGLE GCS_angle, ANTENNA_FIELD LCS_field) //GCS_angle degree
{
	ANTENNA_FIELD GCS_field;
	double cos_psi;
	double sin_psi;
	double theta = GCS_angle.theta * pi / 180;
	double phi = GCS_angle.phi * pi / 180;

	if ((pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2) == 1) || (pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2) == 1))
	{
		theta += 0.0001;
	}

	cos_psi = (cos(beta)*cos(gamma)*sin(theta) - (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*cos(theta)) / sqrt(1.0 - pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2));
	sin_psi = (sin(beta)*cos(gamma)*sin(phi - alpha) + sin(gamma)*cos(phi - alpha)) / sqrt(1.0 - pow(cos(beta)*cos(gamma)*cos(theta) + (sin(beta)*cos(gamma)*cos(phi - alpha) - sin(gamma)*sin(phi - alpha))*sin(theta), 2));;

	GCS_field.theta = cos_psi * LCS_field.theta - sin_psi * LCS_field.phi;
	GCS_field.phi = sin_psi * LCS_field.theta + cos_psi * LCS_field.phi;

	return GCS_field;

}



complex <double> Generate_vertical_virtualization_weight_link(double theta, double dv, double k, double K)
{
	complex <double> j(0.0, 1.0);
	complex <double> w;

	w = 1.0 / sqrt(double(K))*exp(-j * 2.0 * pi / Wavelength * k * dv*cos(theta));

	return w;
}


complex <double> Generate_horizontal_virtualization_weight_link(double theta, double phi, double dH, double l, double L)
{
	complex <double> j(0.0, 1.0);
	complex <double> v;

	v = 1.0 / sqrt(double(L))*exp(-j * 2.0 * pi / Wavelength * l * dH * sin(theta) * sin(phi));

	return v;
}

double Transform_angle_minus_180_to_plus_180(double x)
{

	x = fmod(x, 360);

	if (x > 180)
	{
		x = x - 360;
	}
	else if (x < -180)
	{
		x = x + 360;
	}

	return x;
}

double Transform_angle_0_to_plus_180(double x)
{
	x = fmod(x, 360);
	if (x > 180)
	{
		x = 360 - x;
	}
	else if ((x < 0) && (x >= -180))
	{
		x = -x;
	}
	else if (x < -180)
	{
		x = x + 360;
	}
	return x;

}