#include "common.h"

#include <Eigen/LU>

/*===================================================================
FUNCTION: Sector::Scheduling( int )
===================================================================*/
void Sector::Scheduling(int _Scheduling_Type, int _self_sec_idx_schedule_part)
{

	int Scheduling_Type_S = _Scheduling_Type;

	if (TYPE == 11)
	{
		if (num_Indoor_TRxP == 1)
		{
			self_bs_idx_schedule_part = (int)((double)_self_sec_idx_schedule_part);
		}
		else
		{
			self_bs_idx_schedule_part = (int)((double)_self_sec_idx_schedule_part / 3.);
		}
		
	}
	else
	{
		self_bs_idx_schedule_part = (int)((double)_self_sec_idx_schedule_part / 3.);
	}
	

	
	if (Scheduling_Type_S == 0)

	{
		Scheduling_RoundRobin();
	}

	else if (Scheduling_Type_S == 1)
	{
		//Scheduling_Proportional_Fair_MU_MIMO_KSIM();

		Scheduling_PF_MU_MIMO();

	}

	else
	{
		cout << "Scheduling_Type input error, Use RoundRobin scheduling......" << endl;
		Scheduling_RoundRobin();
	}

}


/*===================================================================
FUNCTION: Sector::Scheduling_RoundRobin( int )
===================================================================*/
void Sector::Scheduling_RoundRobin(void)
{
	/*===================================================================
	FUNCTION : Read_Ch_Feedback()
	INPUT    : pppPMI_map,pppCQI_map
	OUTPUT   : PMI_read, CQI_read, MCS_decision,CQI_AVR,METRIC
	===================================================================*/
	Read_Ch_Feedback();

	/*===================================================================
	FUNCTION : Initialize_schedule_map()
	ppschedulewrite[rb_idx][stream].ue_selected
	ppschedulewrite[rb_idx][stream].mcs_selected
	===================================================================*/
	Initialize_schedule_map();

	////////////////////////////////////////////////////////////////////
	if (W == NULL)
	{
		W = new MatrixXcd[num_rbs_in_1ms];

		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			MatrixXcd temp = MatrixXcd::Zero(4, 2);
			W[freq_idx] = temp;
		}
	}
	////////////////////////////////////////////////////////////////////

	///cout << "ue_in_control.size() = " << ue_in_control.size() << endl;

	int selected_ue = (int)(ue_in_control.size() * randnum.u()); //// one user has 50 RB (when num_TX == 1) 
	int selected_ue_2 = (int)(ue_in_control.size() * randnum.u()); //// one user has 50 RB (when num_TX == 1) 
	if (selected_ue == selected_ue_2)
	{
		if (selected_ue == 0)
		{
			selected_ue_2 = selected_ue + 1;
		}
		else
		{
			selected_ue_2 = selected_ue - 1;
		}
		
	}


	for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
	{
		for (int stream = 0; stream < mx_ue_mumimo; stream++)
		{

			//if (stream == 0)
			//{
				ppschedulewrite[rb_idx][stream].ue_selected = ue_in_control[selected_ue];
			//}
			//else
			//{
				//ppschedulewrite[rb_idx][stream].ue_selected = ue_in_control[selected_ue_2];
			//}
		}

	}

	/*===================================================================
	FUNCTION : Set_AVR_Cqi()
	INPUT    : CQI_read
	OUTPUT   : ppschedulewrite[freq_idx][stream].mcs_selected
	===================================================================*/
	Set_AVR_Cqi();
}

void Sector::Scheduling_Proportional_Fair_MU_MIMO_KSIM(void)
{

	Read_Ch_Feedback();
	Initialize_schedule_map();

	////////////////////////////////////////////////////////////////////
	if (W == NULL)
	{
		W = new MatrixXcd[num_rbs_in_1ms];

		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			MatrixXcd temp = MatrixXcd::Zero(4, 2);
			W[freq_idx] = temp;
		}
	}
	////////////////////////////////////////////////////////////////////

	//////////////////////////////// User selection /////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////
	int Max_mimo_user = 8;
	num_ue_scheduled_mumimo = 0;
	ue_scheduled_mumimo = VectorXd::Zero(Max_mimo_user);

	int numMax_mimo_user = MIN(Max_mimo_user, ue_in_control.size());

	if (numMax_mimo_user == 0);
	else
	{
		VectorXd attachedUE;
		attachedUE = VectorXd::Zero(ue_in_control.size());

		for (int ueID = 0; ueID < (int)ue_in_control.size(); ueID++)
		{
			attachedUE(ueID) = ue_in_control[ueID];
		}

		VectorXd *groupMetric;
		groupMetric = new VectorXd[numMax_mimo_user];
		VectorXd groupMetricValue;
		groupMetricValue = VectorXd::Zero(numMax_mimo_user);

		for (int num_user = 0; num_user < numMax_mimo_user; num_user++)
		{
			groupMetric[num_user] = VectorXd::Zero(num_user + 1);
			printCombination(attachedUE, groupMetric[num_user], groupMetricValue(num_user), (int)ue_in_control.size(), num_user+1);


		}

		VectorXd::Index max_index;
		groupMetricValue.maxCoeff(&max_index);
		VectorXd temp = groupMetric[max_index];


		int tempMS = 0;
		for (int i = 0; i < temp.size(); i++)
		{
			ue_scheduled_mumimo(tempMS) = ue_in_control[temp(i)];
			num_ue_scheduled_mumimo++;

		}




	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////


	///cout << "ue_in_control.size() = " << ue_in_control.size() << endl;

	int selected_ue = (int)(ue_in_control.size() * randnum.u()); //// one user has 50 RB (when num_TX == 1) 

	for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
	{
		for (int stream = 0; stream < mx_ue_mumimo; stream++)
		{
			ppschedulewrite[rb_idx][stream].ue_selected = ue_in_control[selected_ue];
		}
	}

	Set_AVR_Cqi();
}






void Sector::printCombination(VectorXd arr, VectorXd groupMetric, double value, int n, int r)
{
	VectorXd data;
	data = VectorXd::Zero(r);
	
	combinationUtil(arr, data, groupMetric, value, 0, n - 1, 0, r);
}

void Sector::combinationUtil(VectorXd arr, VectorXd data, VectorXd groupMetric, double value, int start, int end, int index, int r)
{
	if (index == r)
	{
		double temp = 0; double metricTemp = 0;
		for (int j = 0; j < r; j++)
		{
			double spectralEfficiency;
			double averagedThroghput;

			int aa = arr(j);

			spectralEfficiency = ms[aa].downlinkspectralefficiency;

			averagedThroghput = ms[aa].downlinkaveragedThroghput;

		

			if (averagedThroghput == 0)
				metricTemp = spectralEfficiency / double(r);
			else
				metricTemp = (spectralEfficiency / averagedThroghput) / double(r);

			temp = temp + metricTemp;
		}
		index = 0;
		if (value < temp)
		{
			groupMetric = data;
			value = temp;
		}
	}

	for (int i = start; i <= end && (end - i + 1) >= (r - index); i++)
	{
		data(index) = arr(i);
		combinationUtil(arr, data, groupMetric, value, i + 1, end, index + 1, r);
	}

}


void Sector::Scheduling_PF_MU_MIMO(void)
{

	Read_Ch_Feedback();
	Initialize_schedule_map();


	////////////////////////////////////////////////////////////////////
	if (W == NULL)
	{
		W = new MatrixXcd[num_rbs_in_1ms];


	}
	////////////////////////////////////////////////////////////////////
	
	int schedule_RB = (int)(num_rbs_in_1ms * randnum.u()); /// choose one random RB -> find scheduled UEs, UEs use 50RB together 

	//cout << "schedule_RB = " << schedule_RB << endl;
	/////////////////////
	Initial_Setting(schedule_RB);
	prev_max_sinr = pow(10., 10.);
	first_max_ue(schedule_RB);
	SUS_procedure(schedule_RB);
	//////////////////////
	
	for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
	{
		for (int ue_idx = 0; ue_idx < scheduled_ue.size(); ue_idx++)
		{
			if (scheduled_ue[ue_idx] > -1)
			{
				ppschedulewrite[rb_idx][ue_idx].ue_selected = ue_in_control[scheduled_ue[ue_idx]];
				ppschedulewrite[rb_idx][ue_idx].mcs_selected = MCS_decision[scheduled_ue[ue_idx]][rb_idx];
			}
		}
		Transmit_Precoding(rb_idx);
	}
		
	/*
	for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
	{
		
		if (rb_idx == 0)  /// when first RB -> find scheduled UEs, UEs use 50RB together 
		{
			Initial_Setting(rb_idx);
			prev_max_sinr = pow(10., 10.);
			first_max_ue(rb_idx);
			SUS_procedure(rb_idx);

			for (int ue_idx = 0; ue_idx < scheduled_ue.size(); ue_idx++)
			{
				if (scheduled_ue[ue_idx] > -1)
				{
					ppschedulewrite[rb_idx][ue_idx].ue_selected = ue_in_control[scheduled_ue[ue_idx]];
					ppschedulewrite[rb_idx][ue_idx].mcs_selected = MCS_decision[scheduled_ue[ue_idx]][rb_idx];

				}
			}
			Transmit_Precoding(rb_idx);
		}
		else
		{
			for (int ue_idx = 0; ue_idx < scheduled_ue.size(); ue_idx++)
			{
				if (scheduled_ue[ue_idx] > -1)
				{
					ppschedulewrite[rb_idx][ue_idx].ue_selected = ue_in_control[scheduled_ue[ue_idx]];
					ppschedulewrite[rb_idx][ue_idx].mcs_selected = MCS_decision[scheduled_ue[ue_idx]][rb_idx];
				}
			}
			Transmit_Precoding(rb_idx);
		}
		
	}
	*/

	Set_AVR_Cqi();

	for (int ue_idx = 0; ue_idx < ue_in_control.size(); ue_idx++)
	{
		for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
		{
			bool unscheduled = 1;
			ms[ue_in_control[ue_idx]].unscheduled_stack += 1;

			for (int stream = 0; stream < mx_ue_mumimo; stream++)
			{
				if (ppschedulewrite[rb_idx][stream].ue_selected == ue_in_control[ue_idx])
				{
					unscheduled = 0;
					ms[ue_in_control[ue_idx]].unscheduled_stack -= 1;
					
				}
			}

			if (CQI_AVR[ue_idx][rb_idx] && unscheduled)
			{
				CQI_AVR[ue_idx][rb_idx] -= (1. / N_pf) * log2(1 + CQI_read[ue_idx][rb_idx]);
				//CQI_AVR[ue_idx][rb_idx] -= (1. / _N_pf) * log2(1 + CQI_read[ue_idx][rb_idx]); 

			}

			
		}
	}



}





void Sector::Read_Ch_Feedback(void)
{

	if (t < N_pf + SCHEDULE_DELAY)
	{
		_N_pf = (t + 1) - SCHEDULE_DELAY;
	}
	else
	{
		_N_pf = N_pf;
	}

	double alpha = 1;


	if (PMI_read == NULL)
	{
		PMI_read = new int    *[ue_in_control.size()];
		CQI_read = new double *[ue_in_control.size()];
		MCS_decision = new int    *[ue_in_control.size()];
		CQIndex_decision = new int    *[ue_in_control.size()]; // 
		CQI_AVR = new double *[ue_in_control.size()];
		METRIC = new double *[ue_in_control.size()];

		PMI_vector_read = new VectorXcd    *[ue_in_control.size()];

		for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
		{
			PMI_read[ue_idx] = new int[num_rbs_in_1ms];
			CQI_read[ue_idx] = new double[num_rbs_in_1ms];
			MCS_decision[ue_idx] = new int[num_rbs_in_1ms];
			CQIndex_decision[ue_idx] = new int[num_rbs_in_1ms];
			CQI_AVR[ue_idx] = new double[num_rbs_in_1ms];
			METRIC[ue_idx] = new double[num_rbs_in_1ms];

			PMI_vector_read[ue_idx] = new VectorXcd[num_rbs_in_1ms];
		}

		for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
		{
			for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
			{
				PMI_read[ue_idx][rb_idx] = 0;
				CQI_read[ue_idx][rb_idx] = 0.;
				MCS_decision[ue_idx][rb_idx] = 0;
				CQIndex_decision[ue_idx][rb_idx] = 0;
				CQI_AVR[ue_idx][rb_idx] = 0;
				METRIC[ue_idx][rb_idx] = 0;

				PMI_vector_read[ue_idx][rb_idx] = VectorXcd::Zero(NUM_TX_Port);
			}
		}
	}

	for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
	{
		for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
		{
			PMI_read[ue_idx][rb_idx] = pppPMI_map[ue_in_control[ue_idx]][rb_idx][(cqi_history_length + t - SCHEDULE_DELAY) % cqi_history_length];
			CQI_read[ue_idx][rb_idx] = pppCQI_Map[ue_in_control[ue_idx]][rb_idx][(cqi_history_length + t - SCHEDULE_DELAY) % cqi_history_length]; 

			PMI_vector_read[ue_idx][rb_idx] = pppPMI_vector_map[ue_in_control[ue_idx]][rb_idx][(cqi_history_length + t - SCHEDULE_DELAY) % cqi_history_length];


			double cqi_offset_added = CQI_read[ue_idx][rb_idx];

			int mcs_up = determine_MCS(10*log10(cqi_offset_added));//+ mcs_offset; /// 
			//int cqi_up = determine_CQI((cqi_offset_added));//+ mcs_offset; /// 
			int cqi_up = mcs_up;

			if (true)  // Use MCS index
			{
				if (mcs_up > 27)
				{
					MCS_decision[ue_idx][rb_idx] = 27;
				}
				else if (mcs_up <0)
				{
					MCS_decision[ue_idx][rb_idx] = 0;
				}
				else
				{
					MCS_decision[ue_idx][rb_idx] = mcs_up;
				}

			}
			else  ///// Use CQI index 
			{
				// save CQI index
				MCS_decision[ue_idx][rb_idx] = mcs_up;

			}




			if (cqi_up > 15)
			{
				CQIndex_decision[ue_idx][rb_idx] = 15;
			}
			else if (cqi_up < 1)
			{
				CQIndex_decision[ue_idx][rb_idx] = 1;
			}
			else
			{
				CQIndex_decision[ue_idx][rb_idx] = cqi_up;
			}


		}

	}


	for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++) 
	{
		for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
		{


			if (CQI_AVR[ue_idx][rb_idx])
			{
				CQI_AVR[ue_idx][rb_idx] = (1. / _N_pf) * log2(1 + CQI_read[ue_idx][rb_idx]) + (1 - 1. / _N_pf) * CQI_AVR[ue_idx][rb_idx];

			}
			else  ///// first loop 
			{
				CQI_AVR[ue_idx][rb_idx] = log2(1 + CQI_read[ue_idx][rb_idx]);


			}
		}
	}

	if (Scheduling_Type == 0)
	{
		for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
		{
			for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
			{

				METRIC[ue_idx][rb_idx] = log2(1 + CQI_read[ue_idx][rb_idx]);//

			}
		}
	}
	else if (Scheduling_Type == 1)  // 
	{
		for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
		{
			for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
			{
				METRIC[ue_idx][rb_idx] = log2(1 + CQI_read[ue_idx][rb_idx]) / ( CQI_AVR[ue_idx][rb_idx] );

				//METRIC[ue_idx][rb_idx] = (CQI_read[ue_idx][rb_idx]) / (CQI_AVR[ue_idx][rb_idx]);

			}
		}
	}
}


int Sector::determine_MCS(double sinr_estimate)
{
	if (false)  //// TS 38.214 , Table 5.1.3.1-2:, use spectral efficiency
	{
		int _MCS_decision = 0;


		if (sinr_estimate < 0.2344)       { _MCS_decision = 0; }
		else if (sinr_estimate < 0.3770)  { _MCS_decision = 1; }
		else if (sinr_estimate < 0.6016)  { _MCS_decision = 2; }
		else if (sinr_estimate < 0.8770)  { _MCS_decision = 3; }
		else if (sinr_estimate < 1.1758)  { _MCS_decision = 4; }
		else if (sinr_estimate < 1.4766)  { _MCS_decision = 5; }
		else if (sinr_estimate < 1.6953)  { _MCS_decision = 6; }
		else if (sinr_estimate < 1.9141)  { _MCS_decision = 7; }
		else if (sinr_estimate < 2.1602)  { _MCS_decision = 8; }
		else if (sinr_estimate < 2.4063)  { _MCS_decision = 9; }
		else if (sinr_estimate < 2.5703)  { _MCS_decision = 10; }
		else if (sinr_estimate < 2.7305)  { _MCS_decision = 11; }
		else if (sinr_estimate < 3.0293)  { _MCS_decision = 12; }
		else if (sinr_estimate < 3.3223)  { _MCS_decision = 13; }
		else if (sinr_estimate < 3.6094)  { _MCS_decision = 14; }
		else if (sinr_estimate < 3.9023)  { _MCS_decision = 15; }
		else if (sinr_estimate < 4.2129)  { _MCS_decision = 16; }
		else if (sinr_estimate < 4.5234)  { _MCS_decision = 17; }
		else if (sinr_estimate < 4.8164)  { _MCS_decision = 18; }
		else if (sinr_estimate < 5.1152)  { _MCS_decision = 19; }
		else if (sinr_estimate < 5.3320)  { _MCS_decision = 20; }
		else if (sinr_estimate < 5.5547)  { _MCS_decision = 21; }
		else if (sinr_estimate < 5.8906)  { _MCS_decision = 22; }
		else if (sinr_estimate < 6.2266)  { _MCS_decision = 23; }
		else if (sinr_estimate < 6.5703)  { _MCS_decision = 24; }
		else if (sinr_estimate < 6.9141)  { _MCS_decision = 25; }
		else if (sinr_estimate < 7.1602)  { _MCS_decision = 26; }
		else if (sinr_estimate < 7.4063)  { _MCS_decision = 27; }
		else                              { _MCS_decision = 27; }


		return _MCS_decision;
	}

	else if (false)  /// CQI
	{
		int _CQI_decision = 0;


		if (sinr_estimate < -9.478)  { _CQI_decision = 1; }
		else if (sinr_estimate < -6.658)  { _CQI_decision = 2; }
		else if (sinr_estimate < -4.098)  { _CQI_decision = 3; }
		else if (sinr_estimate < -1.798)  { _CQI_decision = 4; }
		else if (sinr_estimate < 0.399)   { _CQI_decision = 5; }
		else if (sinr_estimate < 2.424)   { _CQI_decision = 6; }
		else if (sinr_estimate < 4.489)   { _CQI_decision = 7; }
		else if (sinr_estimate < 6.367)   { _CQI_decision = 8; }
		else if (sinr_estimate < 8.456)   { _CQI_decision = 9; }
		else if (sinr_estimate < 10.266)  { _CQI_decision = 10; }
		else if (sinr_estimate < 12.218)  { _CQI_decision = 11; }
		else if (sinr_estimate < 14.122)  { _CQI_decision = 12; }
		else if (sinr_estimate < 15.849)  { _CQI_decision = 13; }
		else if (sinr_estimate < 17.786)  { _CQI_decision = 14; }
		else                              { _CQI_decision = 15; }


		return _CQI_decision;

	}

	else if (true)  
	{
		int _CQI_decision = 0;

		int _MCS_decision = 0;




			/// VIENNA curve

		if (sinr_estimate > SINR_threshold_dB[14])       { _CQI_decision = 15; }
		else if (sinr_estimate > SINR_threshold_dB[13])  { _CQI_decision = 14; }
		else if (sinr_estimate > SINR_threshold_dB[12])  { _CQI_decision = 13; }
		else if (sinr_estimate > SINR_threshold_dB[11])  { _CQI_decision = 12; }
		else if (sinr_estimate > SINR_threshold_dB[10])  { _CQI_decision = 11; }
		else if (sinr_estimate > SINR_threshold_dB[9])  { _CQI_decision = 10; }
		else if (sinr_estimate > SINR_threshold_dB[8])  { _CQI_decision = 9; }
		else if (sinr_estimate > SINR_threshold_dB[7])  { _CQI_decision = 8; }
		else if (sinr_estimate > SINR_threshold_dB[6])  { _CQI_decision = 7; }
		else if (sinr_estimate > SINR_threshold_dB[5])  { _CQI_decision = 6; }
		else if (sinr_estimate > SINR_threshold_dB[4])  { _CQI_decision = 5; }
		else if (sinr_estimate > SINR_threshold_dB[3])  { _CQI_decision = 4; }
		else if (sinr_estimate > SINR_threshold_dB[2])  { _CQI_decision = 3; }
		else if (sinr_estimate > SINR_threshold_dB[1])  { _CQI_decision = 2; }
		else if (sinr_estimate > SINR_threshold_dB[0])  { _CQI_decision = 1; }
		else                                            { _CQI_decision = 1; }



			//_CQI_decision = 8;



			// TS 36.101  TABLE A.4-7  MCS Scheme 1
			if      (_CQI_decision == 1)   { _MCS_decision = 0;  }
			else if (_CQI_decision == 2)   { _MCS_decision = 0;  }
			else if (_CQI_decision == 3)   { _MCS_decision = 2;  }
			else if (_CQI_decision == 4)   { _MCS_decision = 4;  }
			else if (_CQI_decision == 5)   { _MCS_decision = 6;  }
			else if (_CQI_decision == 6)   { _MCS_decision = 8;  }
			else if (_CQI_decision == 7)   { _MCS_decision = 11; }
			else if (_CQI_decision == 8)   { _MCS_decision = 13; }
			else if (_CQI_decision == 9)   { _MCS_decision = 16; }
			else if (_CQI_decision == 10)  { _MCS_decision = 18; }
			else if (_CQI_decision == 11)  { _MCS_decision = 21; }
			else if (_CQI_decision == 12)  { _MCS_decision = 23; }
			else if (_CQI_decision == 13)  { _MCS_decision = 25; }
			else if (_CQI_decision == 14)  { _MCS_decision = 27; }
			else if (_CQI_decision == 15)  { _MCS_decision = 27; }



			return _MCS_decision;

	
	}


	else  //  old code
	{

		/*
		int _MCS_decision = 0;



	//	cout << "sinr_estimate dB = " << sinr_estimate << endl;


		for (int threshold_idx = 0; threshold_idx < NUM_CQI_MCS_TYPES - 1; threshold_idx++)
		{

			if (sinr_estimate < Threshold[0])
			{
				_MCS_decision = 0;
			}
			else if (sinr_estimate >= Threshold[threshold_idx] && sinr_estimate  < Threshold[threshold_idx + 1])
			{
				_MCS_decision = threshold_idx;
			}
			else if (sinr_estimate > Threshold[NUM_CQI_MCS_TYPES - 1])
			{
				_MCS_decision = NUM_CQI_MCS_TYPES - 1;
			}



		}


		return _MCS_decision;

		*/

	}


	
}





int Sector::determine_CQI(double sinr_estimate)
{

	if (true)  /// CQI
	{
		int _CQI_decision = 0;


		if (sinr_estimate > SINR_threshold_dB[14])       { _CQI_decision = 15; }
		else if (sinr_estimate > SINR_threshold_dB[13])  { _CQI_decision = 14; }
		else if (sinr_estimate > SINR_threshold_dB[12])  { _CQI_decision = 13; }
		else if (sinr_estimate > SINR_threshold_dB[11])  { _CQI_decision = 12; }
		else if (sinr_estimate > SINR_threshold_dB[10])  { _CQI_decision = 11; }
		else if (sinr_estimate > SINR_threshold_dB[9])  { _CQI_decision = 10; }
		else if (sinr_estimate > SINR_threshold_dB[8])  { _CQI_decision = 9; }
		else if (sinr_estimate > SINR_threshold_dB[7])  { _CQI_decision = 8; }
		else if (sinr_estimate > SINR_threshold_dB[6])  { _CQI_decision = 7; }
		else if (sinr_estimate > SINR_threshold_dB[5])  { _CQI_decision = 6; }
		else if (sinr_estimate > SINR_threshold_dB[4])  { _CQI_decision = 5; }
		else if (sinr_estimate > SINR_threshold_dB[3])  { _CQI_decision = 4; }
		else if (sinr_estimate > SINR_threshold_dB[2])  { _CQI_decision = 3; }
		else if (sinr_estimate > SINR_threshold_dB[1])  { _CQI_decision = 2; }
		else if (sinr_estimate > SINR_threshold_dB[0])  { _CQI_decision = 1; }
		else                                            { _CQI_decision = 1; }

		return _CQI_decision;




	}
}


/*===================================================================
FUNCTION: Sector::Initialize_schedule_map( int )
===================================================================*/
void Sector::Initialize_schedule_map(void)
{
	for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
	{
		for (int stream = 0; stream < mx_ue_mumimo; stream++)
		{
			ppschedulewrite[rb_idx][stream].ue_selected = -1;
			ppschedulewrite[rb_idx][stream].mcs_selected = -1; // intitialize
			ppschedulewrite[rb_idx][stream].cqi_selected = -1; // intitialize
			ppschedulewrite[rb_idx][stream].capacity = -1; // intitialize
		}
	}

}



/*===================================================================
FUNCTION: Sector::Set_AVR_Cqi( void )
DESCRIPTION: Check the cqi for every allocated resource block, and Set it with minimum Cqi.
===================================================================*/

void Sector::Set_AVR_Cqi(void)   ////
{
	for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
	{
		int count = 0;
		double sum = 0;

		int count_i = 0;
		double sum_i = 0;

		int count_cap = 0;
		double sum_cap = 0;
		double e_sinr[15] = { 0. };
		int decision_CQI_index = 0;
		
		int determined_cqi;
		int determined_mcs;
		double avr_cqi;
		double avr_cqi_interfer = 0.;
		double avr_capacity;

		//MatrixXcd identity = MatrixXcd::Identity(NUM_RX,NUM_RX);


		MatrixXcd identity_RX = MatrixXcd::Identity(NUM_RX_Port, NUM_RX_Port);
		MatrixXcd identity_TX = MatrixXcd::Identity(NUM_TX_Port, NUM_TX_Port);


		//MatrixXcd H_Hh = MatrixXcd::Zero(NUM_RX, NUM_RX);
		MatrixXcd CAP = MatrixXcd::Zero(NUM_RX_Port, NUM_RX_Port);
		double A;


		//cout << "(int)ue_in_control.size() = " << (int)ue_in_control.size() << endl;
		//cout << "ue_in_control[ue_idx] = " << ue_in_control[ue_idx] << endl;
		
		/*
		//////////////////////////////////////////////////////
		///////////////////////// Capacity
		///////////////////////////////////////////////////////
		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			for (int stream = 0; stream < NUM_TX_Port; stream++)
			{
				if (ppschedulewrite[freq_idx][stream].ue_selected == ue_in_control[ue_idx])
				{

					double linear_signal = dBm2linear(link[ue_in_control[ue_idx]].str_signal);
					//double linear_signal = dBm2linear(link[ue_in_control[ue_idx]].signal_power_minus_antgain);
					double linear_interference = dBm2linear(link[ue_in_control[ue_idx]].interference);
					complex <double> det = 0;

					linear_interference = linear_interference + noise;

					CAP = identity_RX + (1 / linear_interference) * ms[ue_in_control[ue_idx]].H_m[freq_idx] * ((linear_signal / NUM_TX_Port)*identity_TX) * ms[ue_in_control[ue_idx]].H_m[freq_idx].adjoint(); ///  Identity_matrix + (1/interference)*H*Rss*Hh 
					det = CAP.determinant();



					A = bandwidth * log2(det.real());  ///




					//A = CQI_read[ue_idx][freq_idx];   ////// SINR

					sum_cap += A;
					count_cap++;
				}
			}
		}
		avr_capacity = sum_cap / (double)count_cap;
		*/

		avr_capacity = 1.;


		double linear_signal = pow(10., link[ue_in_control[ue_idx]].str_signal / 10.);
		MatrixXcd B;
		MatrixXcd eye = MatrixXcd::Identity(NUM_RX_Port, NUM_RX_Port);
		double linear_interference = pow(10., link[ue_in_control[ue_idx]].interference / 10.) + noise;
		B = eye;   // 2x2

		///////////////////////////////////////
		//// Average SINR
		//////////////////////////////////////
		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			for (int stream = 0; stream < mx_ue_mumimo; stream++)
			{
				if (ppschedulewrite[freq_idx][stream].ue_selected == ue_in_control[ue_idx])
				{
					//sum += CQI_read[ue_idx][freq_idx] * linear_interference;
					//sum += CQI_read[ue_idx][freq_idx] * (linear_interference*B.norm());

					sum += CQI_read[ue_idx][freq_idx];
					count++;
				}
			}
		}



		avr_cqi = (sum / (double)count);   //// <- linear average signal power

		avr_cqi_interfer = 1.;




		double avr_SINR = 10. * log10(avr_cqi);

		
		determined_mcs = determine_MCS(avr_SINR);// + 3;
		determined_cqi = determine_CQI(avr_SINR);// + 3;

		//determined_mcs = determine_MCS(10 * log10(avr_cqi));// + 3;
		//determined_cqi = determine_CQI(10 * log10(avr_cqi));// + 3;
		



		if (determined_mcs > 27)
		{
			determined_mcs = 27;
		}
		else if (determined_mcs < 0)
		{
			determined_mcs = 0;
		}

		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			for (int stream = 0; stream < mx_ue_mumimo; stream++)
			{
				if (ppschedulewrite[freq_idx][stream].ue_selected == ue_in_control[ue_idx])
				{
					ppschedulewrite[freq_idx][stream].mcs_selected = determined_mcs;
					ppschedulewrite[freq_idx][stream].cqi_selected = determined_cqi;
					ppschedulewrite[freq_idx][stream].capacity = avr_capacity;

				}
			}
		}



	}
}




/*===================================================================
FUNCTION: Sector::Initial_Setting( int )

DESCRIPTION:
===================================================================*/
void Sector::Initial_Setting(int rb_idx)
{
	scheduled_ue.clear();
	selected_ue.clear();
	prev_sum_SINR = -pow(10., 10.);
	sum_of_SINR = 0.;

	for (int stream = 0; stream < mx_ue_mumimo; stream++)
	{
		ppschedulewrite[rb_idx][stream].ue_selected = -1;
	}
}


void Sector::first_max_ue(int rb_idx)
{
	selected_ue.clear();

	double MAX_SINR = -pow(10., 10.);
	int    MAX_UE = -1;


		for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
		{
			if (METRIC[ue_idx][rb_idx] > MAX_SINR &&  METRIC[ue_idx][rb_idx] < prev_max_sinr)
			{
				MAX_SINR = METRIC[ue_idx][rb_idx];
				MAX_UE = ue_idx;
			}
		}
		selected_ue.push_back(MAX_UE);
		prev_max_sinr = MAX_SINR;



}

/*===================================================================
FUNCTION: Sector::SUS_procedure( int )

DESCRIPTION: Sector object gets to know the index of itself
===================================================================*/
void Sector::SUS_procedure(int rb_idx)
{


	/////
	// SUS = semi orthogonal User selection
	////
	


	while (1) //selected_ue.size() != num_transmit_antenna
	{
		if (selected_ue[0] == -1)  
		{
			break;
		}

		if (selected_ue[selected_ue.size() - 1] > -1)
		{
			Get_User_Set(rb_idx); 


			double MAX_SINR = -500;
			int    MAX_UE = -1;
			for (int j = 0; j < (int)user_set.size(); j++)
			{
				if (METRIC[user_set[j]][rb_idx] > MAX_SINR)
				{
					MAX_SINR = METRIC[user_set[j]][rb_idx];
					MAX_UE = user_set[j];
				}
			}
			selected_ue.push_back(MAX_UE);
		}
		else
		{
			//cout << "selected_ue.push_back -1 = SUS procedure" << endl;
			//getchar();
			selected_ue.push_back(-1);
		}

		if (selected_ue.size() == mx_ue_mumimo || selected_ue.size() == ue_in_control.size()) 
		{
			scheduled_ue = selected_ue;
			break;

			/*
			for (int i = 0; i < (int)selected_ue.size(); i++)
			{
				if (selected_ue[i] > -1)
				{
					sum_of_SINR += METRIC[selected_ue[i]][rb_idx];
				}
			}

			if (sum_of_SINR > prev_sum_SINR + 0.000000009)
			{
				scheduled_ue = selected_ue;
				prev_sum_SINR = sum_of_SINR;
			}
			sum_of_SINR = 0.;

			first_max_ue(rb_idx);
			*/
		}
	}
}


void Sector::Get_User_Set(int rb_idx)
{
	user_set.clear();

	int MIN_SUS_user_idx = 0;
	double MIN_inner_prod = -1;

	for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
	{
		bool already_selected = false;

		for (int _ue_idx = 0; _ue_idx < (int)selected_ue.size(); _ue_idx++)
		{
			if (ue_idx == selected_ue[_ue_idx])
			{
				already_selected = true;
			}
		} 


		bool semi_orthogonal = false;


		if (!already_selected)
		{
			semi_orthogonal = true;


			for (int j = 0; j < (int)selected_ue.size(); j++)
			{
				double MAX_Corr = -500;


				RowVectorXcd A = PMI_vector_read[selected_ue[j]][rb_idx] / PMI_vector_read[selected_ue[j]][rb_idx].norm();
				RowVectorXcd B = PMI_vector_read[ue_idx][rb_idx] / PMI_vector_read[ue_idx][rb_idx].norm();

				double inner_prod = (A * B.adjoint()).norm();



				if (inner_prod > epsilon)  
				{
					semi_orthogonal = false;
				}


				// No select -> find min inner prod
				
				if (MIN_inner_prod < 0)
				{
					MIN_inner_prod = inner_prod;

					MIN_SUS_user_idx = ue_idx;
				}
				else if (MIN_inner_prod > inner_prod)
				{
					MIN_inner_prod = inner_prod;

					MIN_SUS_user_idx = ue_idx;
				}
				



				semi_orthogonal = true;
			}

		}

		if (semi_orthogonal) 
		{
			user_set.push_back(ue_idx);
		}
	}

	
	// No select -> find min inner prod
	//if (user_set.size() == 0)
	//{
	//	user_set.push_back(MIN_SUS_user_idx);
	//}
	




}



/*===================================================================
FUNCTION: Sector::Transmit_Precoding( int )

DESCRIPTION:
===================================================================*/
void Sector::Transmit_Precoding(int rb_idx)
{
	MatrixXcd Lambda = MatrixXcd::Zero(mx_ue_mumimo,NUM_TX_Port);

	MatrixXcd Identity = Matrix2cd::Identity();



	for (int i = 0; i < (int)scheduled_ue.size(); i++) 
	{
		if (scheduled_ue[i] > -1)
		{

			RowVectorXcd v_hat = PMI_vector_read[scheduled_ue[i]][rb_idx].transpose();  //// 1xT

			Lambda.row(i) = v_hat;

		}
	}


	// Check What is the optimal value for the regularized channel inversion ?
	//complex <double> _det = ((Lambda * Lambda.adjoint()).inverse()).determinant();



	W[rb_idx] = Lambda.adjoint() * (Lambda * Lambda.adjoint()).inverse();




	VectorXd sqrt_p = VectorXd::Zero(mx_ue_mumimo);

	for (int i = 0; i < mx_ue_mumimo; i++)  
	{
		sqrt_p(i) = (W[rb_idx].col(i)).norm();
	}



	W[rb_idx] = W[rb_idx] * sqrt_p.asDiagonal();
	

	
	
}


/*===================================================================
FUNCTION: Sector::Set_Min_Cqi( void )

AUTHOR: SJ, KR, DW

DESCRIPTION: Check the cqi for every allocated resource block, and Set it with minimum Cqi.

NOTES: Updated 6 OCT 08
===================================================================*/
void Sector::Set_Min_Cqi(void)
{
	for (int ue_idx = 0; ue_idx < (int)ue_in_control.size(); ue_idx++)
	{
		int min_cqi = NUM_CQI_MCS_TYPES;
		// MIN CQI within UE setting for each frequency
		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			for (int stream = 0; stream < mx_ue_mumimo; stream++)
			if (ppschedulewrite[freq_idx][stream].ue_selected == ue_in_control[ue_idx])
			{
				if (min_cqi > MCS_decision[ue_idx][freq_idx])
				{
					min_cqi = MCS_decision[ue_idx][freq_idx];
				}
			}
		}

		// Set MIN CQI Scheduling for each frequency
		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			for (int stream = 0; stream < mx_ue_mumimo; stream++)
			if (ppschedulewrite[freq_idx][stream].ue_selected == ue_in_control[ue_idx])
			{
				ppschedulewrite[freq_idx][stream].mcs_selected = min_cqi;
			}
		}
	}
}

